AS-2002-10-07-0: CVS        Created V53p3_TAG --> SGE 5.3p3
-----------------------------------------------------------

EB-2003-02-14-1  Enhancem.: Enabled qmaster profiles code

JG-2003-02-14-0  Bugfix:    Second migration of tightly integrated jobs failed
                            if any host was used in both the first and second
                            run of the job.
                 Review:    AH
                 Changed:   sge_qmaster

EB-2003-02-14-0  Testsuite: new test which will find #226 
                 IZ:        #364

JG-2003-02-13-1  Enhancem.: Disabled use of non unique hashtable in scheduler.
                            It has negative performance impact on job sorting.
                 Changed:   sge_schedd

JG-2003-02-13-0  Bugfix:    Fixed improper use of hashtable in scheduler.
                 Enhancem.: Improved test program for the cull hash 
                            implementation.
                 Review:    EB
                 Changed:   sge_schedd

EB-2003-02-13-0  Enhancem.: Added PROFILE parameter to qmaster_params.
                            Addtional logging concerning spooling in qmaster.
                 Changed:   sge_qmaster 
                 Review:    AH
                 Note:      New code is not enabled per default!
                            Compile with: ./aimk -DPROFILE_MASTER 

JG-2003-02-12-0  Enhancem.  Disabled hashing by job onwner in schedd's job list
                            - it doesn't give the expected performance 
                            improvement.

AA-2003-02-11-0  Bugfix:    qmon crash fixed for pressing Why ? when several
                            jobs are selected.
                 Changed:   qmon
                 Bugtraq:   4816529
                 IZ:        #490

JG-2003-02-11-0  Enhancem.  Improved ineffective implementation of removing 
                            entries in nonunique hashtables.
                            Added a test program for cull_hash.
                 Review:    EB

AS-2003-02-10-1  Bugfix:    scripts/util/arch: backed out hp11-64 and aix51
                            detection since no port available yet
                 IZ:        #486
                 
AS-2003-02-10-0  Changed:   libs/gdi/version.c: set version to 5.3p3

CR-2003-02-07-1  Bugfix:    Compile warnings for ALINUX fixed

CR-2003-02-07-0  Enhancem.: Modified qevent client for testsuite throughput
                            test

EB-2003-02-07-0  Bugfix:    Optimization in scheduler which will have an
                            effect if maxujobs != 0 and many different users
                            submit jobs.
                 Changed:   sge_schedd
                 Review:    AH

JG-2003-02-07-0  Bugfix:    Optimization in creation of new cull hashtables.
                 Changed:   sge_schedd (all)
                 Review:    EB

CR-2003-02-05-3  L10N:      Removed unused message macro (ID:15004)
                            "qrsh_starter: cannot read environment variable"
                 Changed:   msg_qrsh.h

EB-2003-02-05-0: Bugfix:    qstat -r shows wrong dependencies
                 IZ:        #478
                 Bugtraq:   #4813188
                 Changed:   qstat

CR-2003-02-05-0: Enhancem.: Modified qevent demo client for testsuite 
                            throughput test compatibility

JG-2003-02-04-0: Bugfix:    qrsh silently truncated job arguments that 
                            exceeded 4k in size.
                 Review:    CR
                 Changed:   qrsh_starter

CR-2003-01-31-0: Bugfix:    qconf -Muser and qconf -Auser report no success
                            messages
                 Bugtraq:   #4811230
                 Review:    AH
                 Changed:   qconf

AH-2003-01-31-0: Bugfix:    wrong usage reported by qstat -j <jobid>
                 Bugtraq:   #4794242
                 IZ:        #446
                 Review:    AS
                 Changed:   sge_execd

JG-2003-01-31-0  Bugfix:    For tightly integrated parallel jobs, the
                            handling of a task exit could be done multiple
                            times resulting in too much accounting entries,
                            probably wrong scheduling decisions and
                            unnecessary spooling overhead.
                 IZ:        #438
                 Bugtraq:   #4791238
                 Review:    AH
                 Changed:   sge_qmaster

JG-2003-01-28-1  Bugfix:    qrsh crashed when job arguments exceeded 4k in
                            size.
                 IZ:        #472
                 Bugtraq:   #4807677
                 Review:    CR
                 Changed:   qsh

JG-2003-01-28-0  Bugfix:    startup failure of qrsh was reported as regular
                            job exit.
                 IZ:        #380
                 Bugtraq:   #4818741
                 Review:    AH
                 Changed:   qrsh_starter, sge_shepherd, qsh

AA-2003-01-24-0  Bugfix:    qsub -C option analogue was missing in qmon
                            remove #$ in submit dialogue's Prefix field to
                            achieve same functionality as qsub -C before
                            loading job with the file dialogue
                 IZ:        #449
                 Bugtraq:   #4802831
                 Review:    JG
                 Changed:   qmon

EB-2003-01-23-1  Bugfix:    execd does process tracking even if no job has
                            to be controlled.
                 IZ:        #416
                 Bugtraq:   #4776016
                 Review:    JG 
                 Changed:   sge_execd

EB-2003-01-23-0  Bugfix:    qacct -l selection broken and
                            qacct -nohist -l selection broken
                 IZ:        #455
                 Bugtraq:   #4802171
                 Review:    JG 
                 Changed:   qacct

AH-2003-01-23-0: Bugfix:    qtcsh can't be used as normal tcsh
                 Bugtraq:   #4776821
                 IZ:        #417
                 Review:    JG
                 Changed:   qtcsh

JG-2003-01-23-0  Bugfix:    Set commlib timeouts in qsh analogous to qsub.
                 Bugtraq:   #4654993 (partial fix)

SD-2003-01-22-0  Enhancem.  Added code to source/libs/cull/cull_list.c to
                            randomize the elements before calling qsort.
                            This code is currently turned off until tests
                            can be run to find out if it improves
                            performance.

EB-2003-01-22-1  Bugfix:    ":" in account string breaks accounting file
                 IZ:        #314
                 Bugtraq:   #4713013
                 Review:    JG 
                 Changed:   sge_qmaster, submit.1

JG-2003-01-22-1  Bugfix:    Empty sge_request file caused submission error.
                 IZ:        #393
                 Bugtraq:   #4760981

AH-2003-01-22-0  Bugfix:    STRING complex attribute handling with 
                            RELOP "!=" is broken
                 IZ:        #450
                 Bugtraq:   #4805423 
                 Review:    CR
                 Changed:   sge_qmaster, sge_schedd, qstat, qhost, qselect, 
                            qacct

EB-2003-01-22-0  Bugfix:    qalter shows wrong priority number when using
                            negative priorities with -p option
                 IZ:        #403
                 Bugtraq:   #4769608
                 Review:    CR
                 Changed:   sge_qmaster

JG-2002-01-20-0  Bugfix:    qsub -C "" (do not parse special comments in
                            script file) did not work.
                 IZ:        #449
                 Bugtraq:   #4802831

SD-2002-12-19-1  Enhancem.  A new qmaster_params attribute called
                            SCHEDULER_TIMEOUT will allow the scheduler GDI
                            event acknowledge timeout (default is 10
                            minutes) to be configured to a specific value. I
                            have also added GEEE profiling information which
                            reports the number of seconds required for
                            specific parts of GEEE scheduling (pending job
                            ticket calculation, job sorting, active job
                            ticket calculation, and job placement). These
                            changes will provide additional feedback for
                            further reducing job scheduling overhead and
                            improving scheduler scalability.

JG-2002-12-19-0  Bugfix:    Wrong error output if a userlist shall be
                            deleted that is still referenced in an execution
                            host.

AH-2002-12-12-0  Bugfix:    conflicting policies can cause job being started
                            and immediately suspended
                 IZ:        #437
                 Bugtraq:   #4790592 
                 Bugfix     failover to shadow master leaves sge_schedd on the  
                            original qmaster host
                 IZ:        #441
                 Bugtraq:   #4787623 
                 Review:    AS

AH-2002-12-11-0  Bugfix:    job arguments larger than 10k crash qmaster
                 IZ:        #440
                 Bugtraq:   #4792036
                 Review:    AS
            
JG-2002-12-11-0  Enhancem.  Improved performance / scalability for job submit.

EB-2002-12-10-0  Bugfix:    job logging file exists but is empty in certain 
                            configurations
                 IZ:        #439
                 Bugtraq:   #4791908
                 Review:    AS

EB-2002-12-09-0  Bugfix:    qstat -j shows messages concerning queues although
                            schedd_job_info=false
                            sge_schedd process consumes more memory than needed
                            if schedd_job_info=true
                            Job notification signals won't be delivered if
                            user redefines suspend_method or terminate_method
                 IZ:        #432 #435 #436
                 Bugtraq:   #4787598 #4790540 #4790547
                 Review:    AS

CR-2002-12-03-0  L10N:      a) When SGE qmaster was started with the global 
                 Bugfix:    variable SGE_ENABLE_MSG_ID=2 (used for L10N debuging 
                            to enable message id's on every l10ned message) and 
                            the host complex was modified the saved complex 
                            configuration file is corrupted ( it contains a 
                            message id [xxxxx] ).  After a shutdown the qmaster 
                            can't read the complex configuration file.

                            b) re-un-commented one message macro not used in 
                            source code, but in testsuite. 
                            (SGE_INFOTEXT_TESTSTRING_S_L10N)

CR-2002-11-28-0  Cleanup:   un-commented message macros not used in source code
                 L10N:

EB-2002-11-25-2  Bugfix:    qstat -f output broken for pe jobs on same queue
                 IZ:        #430
                 Bugtraq:   #4795475
                 Review:    CR

EB-2002-11-25-1  Testsuite: Added new tests which will find bug #126
                 IZ:        #427

EB-2002-11-25-0  Bugfix:    race condition if signals are to be delivered in 
                            job's startup phase
                 IZ:        #126
                 Bugtraq:   #4780316
                 Review:    AH

CR-2002-11-19-1  L10N       removed message definition macro only used in

CR-2002-11-22-4  Testsuite: qmod - reschedule test:
                               parallel job test should not submit job with
                               -t 1 parameter (-t 1 is now a task job, this
                               leaded into a missinterpretation of testsuite)

                 Changed:   testsuite/checktree/system_tests/clients/qmod/reschedule/check.exp 

AA-2002-11-21-0  Security:  SHA_1 define, sge_ca enhancements to support sha-1,
                            pkcs12

CR-2002-11-22-1  Bugfix:    Uninitialized pointer cause segmentation fault in 
                            qsh/qrsh on submit only hosts.
                 Changed:   qsh/qrsh
                 Bugtraq:   #4815774
                 IZ:        #487

AA-2002-11-21-0  Bugfix:    aix51 arch in util/arch script

CR-2002-11-19-1  L10N:      removed message definition macro only used in
                            ptf module for IRIX6 / IRIX64 architecture. The
                            message should not be l10n-ed.
                 Changed:   execd (on IRIX6/IRIX64 )

CR-2002-11-19-0  L10N:      Code cleanup/enhancements for testsuite l10n
                            modulation.
                            - removed unused message definitions from msg_xxx.h                               
                              files
                            - new printf() format carsting specifier macro: 
                              X32CFormat (%lx) - x32c() (analog to 
                              U32CFormat/u32c())
                            - new command line parameters for infotext binary:
                              raw     (return localized format string)
                              __eoc__ (stop option parsing after this 
                              parameter) 
                 Changed:   qsh, infotext

AH-2002-11-18-0  Bugfix:    Complex values for user defined complexes  
                            are rejected with global host.
                 IZ:        #418
                 Bugtraq:   #4776754
                 Review:    AS

EB-2002-11-18-0  Testsuite: Test for issue #423 and #402
                 IZ:        #425, #426

EB-2002-11-14-0  Bugfix:    - memopy leak in execd
                            - stepsize 0 in array job specification
                              results in qmaster exception
                            - job env variables SGE_TASK_* might be
                              overwritten by qsub -v
                 IZ:        #423, #424, #402, #264
                 Bugtraq:   #4778757, #4778758, #4778762
                 Review:    JG

AA-2002-11-14-0  Kerberos:  changes to fix build problems with krb5

CR-2002-11-07-0  Testsuite: sort checktree directory path list before starting
                            test run to get an alphabetic test run order.

AS-2002-10-24-0  Bugfix:    'mk_ascman' script always checked out man pages
                            from maintrunk

SD-2002-10-17-0  Bugfix:    SGEEE - Fixed bug in the pending functional
                            ticket calculation which incorrectly
                            calculated the number of functional tickets
                            for some pending jobs.
                 Changed:   sge_schedd

SD-2002-10-15-0  Bugfix:    Fix no newline problem with path alias file If
                            the last line in the path aliases file
                            (sge_aliases) did not have a new line, qsub
                            would core.
                 IZ:        #398
                 Bugtraq:   #4816541
                 Changed:   qsub, qsh, qmon, ...

AH-2002-10-10-0  Bugfix:    Fix problem with user .cshrc error causing
                            [pro|epi]log,pe-[start|stop] failure and setting
                            queue into error state.
                            [pro|epi]log,pe-[start|stop] are now started
                            with "unix_behavior" i.e plain execvp().  This
                            allows admins to prevent .cshrc/.profile from
                            being sourced when #!/bin/csh -f or #!/bin/sh -f
                            is used.
                 IZ:        391
                 Bugtraq:   4756556
                 Review:    AS
                 Changed    sge_shepherd

AH-2002-10-08-0  Bugfix:    Commd read the host alias file each time when 
                            a hostname was not found in commd's host list.
                            Now host alias file only read at commd startup
                            or when a COMMD_UNIQUEHOST request with
                            refresh_aliases = true is received. 
                 Review:    AS
                 Changed:   sge_commd

AH-2002-10-07-0  Bugfix:    Fixed problem with non-resvolvable hosts in
                            host_aliases file causing wrong resolving
                            results.
                 IZ:        #392
                 Bugtraq:   #4756557
                 L10N:      added two new messages 
                 Review:    AS
                 Changed:   sge_qmaster, gethostbyname, gethostname


AS-2002-10-07-0: CVS        Created V53p2_TAG --> SGE 5.3p2
-----------------------------------------------------------

CR-2002-10-02-0  Testsuite: added sleep 1 command in procedure "delete_job"
                            and Workaround increased wait timeout. Testsuite
                            seems to have problems with deleting jobs. This
                            may be connected with IZ issue
                            #126 (qdel of just submitted job). When the signal  
                            delivering bug is fixed, the timeout and the sleep
                            should be taken back.


EB-2002-10-01-0  Bugfix:    using SGE_STRUCT_STAT instead of original stat 
                            struct
                 IZ:        389
                 Bugtraq:   4755931
                 Review:    AS

CR-2002-09-30-1  Testsuite: qsh/qrsh does not accept -o/-e arguments anymore
                 Bugfix:

CR-2002-09-30-0  Testsuite: added versions 5.3.1beta9 and 5.3p2

EB-2002-09-30-0  Bugfix:    EB-2002-08-29-0 fix.
                 Review:    AH

AS-2002-09-27-0  Fix:       Update for loose Sun HPC cluster tools
                            integration

AA-2002-09-26-0  Fix:       aimk - ENABLE_213_FIX, ENABLE_214_FIX define
                            !! Attention, aimk clean !!
                            qmon_matrix.c DPRINTF() debug message added

JG-2002-09-26-0  Testsuite: Introduce architectures aix51 and hp11-64 for
                            control_procedures and qmaster size test.

EB-2002-09-25-0  Bugfix:    Exiting sgeee jobs will be shown in qmons dialog 
                            for pending jobs.
                 IZ:        388 
                 Changed:   qmon

CR-2002-09-24-1  Bugfix:    linux clients use port 65535 by error if
                            COMMD_PORT/sge_commd service not set
                 Bugtraq:   #4750818
                 Changed:   all clients using commlib

JG-2002-09-24-0  Enhancem.: Initial Part of port for HP-UX 11 64 bit

CR-2002-09-24-0  Testsuite: install_core_system check: wait for 
                            default/spool/configuration file to appear at 
                            remote host before starting to install an execution
                            host. 
                 Bugfix:

CR-2002-09-23-2  Bugfix:    2 sentences need to be i18ned in master 
                 Bugtraq:   #4746079

CR-2002-09-23-1  Bugfix:    infotext doesn't support the reorder of conversion
                            specifications
                 Bugtraq:   #4739811
                 Changed:   infotext
                            Bug not fixed for ALPHA, ALPHA5, ALINUX architecture

CR-2002-09-20-0  Bugfix:    infotext doesn't support the reorder of conversion
                            specifications
                 Bugtraq:   #4739811
                 Changed:   infotext

EB-2002-09-19-0  Bugfix:    prevent deletion of still referenced objects
                            - PE objects
                            - CKPT objects
                 IZ:        #302 
                 Bugtraq:   #4753668
                 Changed:   sge_qmaster

SD-2002-09-19-0  Bugfix:    Fixed restart_command for checkpoint jobs
                 IZ:        #383
                 Changed:   sge_shepherd

EB-2002-09-18-0  Bugfix:    qconf gets commd timeout
                 IZ:        #308
                 Bugtraq:   #4753669 
                 Review:    AH
                 Changed:   qconf

JG-2002-09-17-0  Bugfix:    If a task of a tightly integrated job died through 
                            a signal (e.g. SIGXCPU), the job was not terminated
                            and the signalling information not visible in the 
                            accounting record.
                 Bugtraq:   #4747829
                 IZ:        #379

CR-2002-09-16-0  Bugfix:    subject containing non-ASCII of notification mail
                            is not encoded properly
                 Bugtraq:   #4740001

CR-2002-09-13-1  Bugfix:    Typo in Message
                 Bugtraq:   #4746705

AA-2002-09-13-0  Bugfix:    QERROR action bugfix for qmon
                            aimk.site -> openssl-0.9.6g
                            aimk -> gettext libs change for gettext 11.4

JG-2002-09-11-1  Bugfix:    qmake without information about parallel execution
                            on commandline failed.
                            qmake made an incorrect resource request if the 
                            ARCH environment variable was an empty string.
                 IZ:        #335, #327
                 Bugtraq:   #4745399, 4745404
                 Changed:   qmake

JG-2002-09-11-0  Bugfix:    qrsh and qlogin accept unexpected options.
                            qsh/qrsh/qlogin did not accept options
                            -ac, -dc, -sc and -w
                 IZ:        #325
                 Bugtraq:   #4716824, #4745387
                 Changed:   qsh, submit.1

EB-2002-09-10-0  Enhancem.: Initial Part of AIX 5.1 port

CR-2002-09-10-0  Bugfix:    L10N - (setlocale() returns e.g. fr_FR on LINUX)
                            cutting of characters after "_" for building message
                            file directory path.

JG-2002-09-10-0  Bugfix:    qsh jobs without or with local DISPLAY variable 
                            set have to be rejected.
                 IZ:        #342
                 Bugtraq:   #4744523
                 Changed:   sge_qmaster, qsh, submit.1

CR-2002-09-09-3  I18N:      fixed script errors which caused loose of some
                            messages in gridengine.pot file 
                 Bugfix:

CR-2002-09-09-1  I18N:      invalid escape sequence in one of msgid
                 Bugtraq:   #4743505
                 Changed:   inst_sgeee usage output

CR-2002-09-09-0  Testsuite: make output check of qdel test independent of
                            l10n message id

EB-2002-09-08-0  Bugfix:    schedd_job_info = true causes immense daemons
                            memory growth
                 IZ:        #374
                 Bugtraq:   #4742189
                 Review:    AH
                 Changed:   sge_schedd

AA-2002-09-05-0  I18N:      - Calculation failure in Functional policy
                            - Wrong mnemonic on qmon main window
                            - qmon dies with changes in Edit Tickets 
                              on Solaris64
                            - suspend_threshold in queue icon display nearly 
                              not visible
                 Bugtraq:   #4742082, #4729085, #4740335
                 IZ:        #350

AS-2002-09-05-1  Bugfix:    "stop" procedure for execd had hardwired execd 
                            spool dir
                 IZ:        #219
                 Bugtraq:   #4742133

AS-2002-09-05-0  Enhancem:  better error message if hostname can't be
                            resolved at commd
                 Changed:   qconf

EB-2002-09-02-1  Bugfix:    qmod help output is incomplete
                 IZ:        #354
                 Bugtraq:   #4741230
                 Review:    AH
                 Changed:   qmod

EB-2002-09-02-0  Bugfix:    load formula of the scheduler
                 IZ:        #330
                 Bugtraq:   #4740578
                 Review:    AS
                 Changed:   sge_qmaster

AS-2002-09-02-0  Bugfix:    Insufficient checking for PTF_*_PRIORITY values
                 IZ:        #333
                 Bugtraq:   #4740407
                 Changed:   sge_execd

AH-2002-09-02-0  Doc:       qmod man page for "-r" incorrect (user)
                            daemons to crash at startup phase
                 IZ:        #193
                 Doc:       job array task index values range not documented
                 IZ:        #283

CR-2002-09-02-0  Testsuite: Merges from maintrunc

EB-2002-09-02-0  Bugfix:    problems with destin_id_list syntax
                 IZ:        #313
                 Bugtraq:   #4740350
                 Review:    AH
                 Changed:   qsub, qalter, qsh
                  
AH-2002-08-30-0  Bugfix:    solaris 32 bit: rlim_fd_max > 1024 can cause 32 bit 
                            daemons to crash at startup phase
                 IZ:        #371
                 Bugtraq:   #4739596
                 Changed:   sge_qmaster sge_execd sge_commd sge_schedd 
                            sge_shadowd

EB-2002-08-29-0  Bugfix:    msg size used in tight PE integr. job start sync. 
                            protocol should be smaller
                 IZ:        #213
                 Bugtraq:   #4658706
                 Review:    AH 

                            THE FIX IS INCORPORATED INTO THE SOURCE CODE
                            BUT IT WILL ONLY BE ACTIVE IF THE SOURCE CODE
                            IS COMPILED WITH A CERTAIN PREPROCESSOR DEFINE

                               > aimk -DENABLE_213_FIX
                 Changed:   sge_qmaster sge_execd

CR-2002-08-29-2  Testsuite: Added SGE/EE version names for testsuite

CR-2002-08-29-0  Bugfix:    corrected mistake in writing in debug messages
                            for localization
                 Changed:   All binaries using i18n

EB-2002-08-28-0  Bugfix:    protocol doing termin. on failure for tightly 
                            integr. par. job could be leaner
                 IZ:        #214
                 Bugtraq:   #4658716
                 Review:    AH 

                            THE FIX IS INCORPORATED INTO THE SOURCE CODE
                            BUT IT WILL ONLY BE ACTIVE IF THE SOURCE CODE
                            IS COMPILED WITH A CERTAIN PREPROCESSOR DEFINE

                              > aimk -DENABLE_214_FIX
                 Changed:   sge_qmaster

AA-2002-08-28-1  I18N:      version string and copyright strings for infotext
                 Review:    AS
                 Changed:   infotext

AA-2002-08-28-0  Bugfix:    OK without hostname in host_configuration kill 
                            sge_qmaster
                 Issues:    #370
                 Bugtraq:   #4732031
                 Review:    CR
                 Changed:   sge_qmaster

AH-2002-08-28-0  Doc:       man page typo for sge_aliases
                 IZ:        #347
                 Doc:       access_list(5) man page does not describe file 
                            format for SGEEE mode
                 IZ:        #357
                 Doc:       Output of prolog/epilog for interactive jobs not
                            mentioned
                 IZ:        #367

EB-2002-08-23-0  Bugfix:    scheduler crashes if defaultuser has 0 shares in 
                            sharetree
                 Issues:    #363
                 Bugtraq:   #4735972
                 Review:    AS
                 Changed:   sge_schedd

AS-2002-08-22-4  CVS        Created V531_beta7_TAG
--------------------------------------------------

AA-2002-08-22-0  I18N:      bunch of fixes for l10n
                 Bugtraq:   #4733802, #4733201, #4733089, #4733043,
                            #4731976, #4731990, #4731967, #4731958,
                            #4731944, #4731935, #4731273, #4729700
                  
AS-2002-08-22-2  I18N:      some msgs. are not anymore dynamically created

AS-2002-08-22-1  Bugfix:    qhold/qrls (via qhold.sh) can print i18ned
                            removed Translate() shell function
                            better gid_range checking in install script
                 Bugtraq:   #4732535           

EB-2002-08-22-0  Bugfix:    Userset "defaultdepartment" accepts users in CLI
                 Bugtraq:   #4733859, #4731347
                 IZ:        #360 ??? #356 ???
                 Review:    AS
                 Changed:   sge_qmaster, qconf

AS-2002-08-22-0  Bugfix:    print correct progname in usage
                 Bugtraq:   #4735258
                 Changed:   sge_qmaster sge_execd, sge_shadowd, sgecommdcntl

AA-2002-08-21-0  Bugfix:    gid_range bugfix for SGE mode in qmon
                 Bugtraq:   #4731288
                 IZ:        #355
                 Changed:   qmon

EB-2002-08-21-0  Bugfix:    qmaster error message during startup: global 
                            configuration doesn't exist - creating
                 Bugtraq:   #4665780
                 Issues:    #226
                 Review:    AS
                 Changed:   sge_qmaster, qconf, qmon

AS-2002-08-19-0  Bugfix:    gethostbyaddr binary not working on solaris64
                 Bugtraq:   #4732545
                 IZ:        #359
                 Changed:   gethostbyaddr

SD-2002-08-14-0  Enhancem.  Updated Kerberos integration to handle
                            cross-domain authentication correctly when
                            storing the forwarded credentials in the
                            credentials cache.
                 Changed:   put_cred

AA-2002-08-09-0  I18N:      - aimk: -lXmu for LINUX6 broke build under special
                                    RHLinux 7.3
                                    HFLAGS for gettext
                            - Cli widget multiple localized message lines 
                            - source/3rdparty/qmon/Xmt310/Xmt/HelpBox.c
                              Bugtraq 4721140
                            - source/3rdparty/qmon/Xmt310/Xmt/FontListCvt.c
                              additional debugging code XMTDEBUGFONT env var
                            - fonts, translations for browser, complex window
                              width (4723532, 4725248), global crash (4728293),
                              locale setting qmon_init.c ad file search,
                              q/j customize dialogue (4723543), 
                              accelerators (4729085), 
                              submit dialogue missing msg translations,
                            - arch dependend *.mo files:
                              locale/{fr|ja|zh}/LC_MESSAGES/<arch>/gridengine.mo 

EB-2002-08-08-0  I18N:      Messages in some types of mail notification are 
                            not i18ned.
                 Bugtraq:   #4728217
                 Changed:   sge_execd, sge_qmaster

AS-2002-08-08-1  Bugfix:    i18n/l10n ready for util/setfileperm.sh
                 Bugtraq:   #4705054

AS-2002-08-08-0  Enhancm.:  cleanup in i18n setup

AS-2002-08-07-0  Bugfix:    wrong setting of SGE_CELL in settings.sh 
                            created by util/create_settings.sh
                 Bugtraq:   #4727457
                 IZ:        #346
 
EB-2002-08-07-0  Bugfix:    maxujobs prevents dispatching even if job limit is
                            not reached
                 IZ:        #345
                 Bugtraq:   #4727515
                 Review:    AH
                 Changed:   sge_schedd

AA-2002-08-01-1  L10N:      Yun's bug list, XtResolvePathname fix in Lookup.c
                            l10n fixes, sge_ca script

CR-2002-07-31-1  Bugfix:    English messages show up when running install 
                            in localized environment (fix for "fr" Solaris 8
                            and 9)   
                 Bugtraq:   #4719203
                 Changed:   all binaries


CR-2002-07-31-0  Bugfix:    addend missing #ifdef __SGE_NO_USERMAPPING__ 
                            lines to preserve sge_options[] array
                 Changed:   qconf          

AH-2002-07-29-1  Doc:       Describe the 'all' keyword for queue_list in
                            sge_pe(5) and checkpoint(5).
                 IZ:        #319
                 Doc:       Describe qconf -mqattr switch as the deprecated
                            form of the -rattr and not of the -mattr switch.
                            Mention that ?attr switch familiy operates also
                            on PE and ckpt objects.
                 IZ:        #321

CR-2002-07-29-1: Bugfix:    corrected CR-2002-07-29-0 and added sc_OPT
                            for qalter binary

CR-2002-07-29-0: Bugfix:    CLI: invalid option "-jid jid" for qconf in 
                            qconf -help
                 Bugtraq:   #4722060
                 Changed:   qalter, qconf, qsh, qrsh, qlogin, qsub

CR-2002-07-26-1: Bugfix:    Wrong path for qmaster messages file in exe host 
                            installation
                 Bugtraq:   #4721181    
 
CR-2002-07-26-0: Bugfix:    Junk messages in installation
                 Bugtraq:   #4705066 (refix)

CR-2002-07-25-2: Merge:     Added some sge_ca options from maintrunc 

CR-2002-07-25-1: I18N:      English messages show up when running install 
                            in localized environment    
                 Bugtraq:   #4719203
                 Changed:   all binaries

CR-2002-07-25-0: Testsuite: bugfix (can't open product mode file - error)
                 Bugfix:    

AA-2002-07-25-0: I18N:      - qmon_about.c copyright under non C locales
                              msg translation must be changed to work
                            - mistranslation in qmon_calendar fixed
                            - added fonts to Q -> no Qmon file in homedir 
                              necessary
                            - check for valid strings in lSetString as
                              possible fix (commented out)
                            - fix of msg_qmaster.h that caused segv of master
                              when using localized q names
                            - change of qmon_messages.ad template
                              about_msg, removed obsolete calendar msgs
                 Bugtraq:   #4719152

CR-2002-07-24-0: Bugfix:    wrong port output in qstat error message when qmaster
                            (merged from maintrunc)
                 IZ:        #331
                 Bugtraq:   #4719755
                 Changed:   commdcntl infotext libcom.a libsec.a libsge.a qacct qalter qconf qdel qevent qhost qmod qmon qsh qstat qsub sge_commd sge_coshepherd sge_execd sge_qmaster sge_schedd sge_shadowd sge_share_mon sge_shepherd tstrcv tstsnd
                            
CR-2002-07-23-1: Testsuite: (merged from maintrunc) 
                            new feature for delete_job: wait for jobend 
                 Bugfix:    project_access_lists and access_lists could not
                            always delete parallel environments, because they
                            was used not full completed jobs


AA-2002-07-23-0: I18N:      sge_ca script infotextized

EB-2002-07-23-0: Bugfix:    qsub/qalter -l <shortcut_name>... might select
                            wrong resource.
                 IZ:        #328
                 Bugtraq:   #4718880
                 Changed:   sge_qmaster

CR-2002-07-22-1: Bugfix:    Junk messages in installation
                 Bugtraq:   #4705066

CR-2002-07-22-0: Testsuite: New version strings for 5.3.1beta3 and beta4
                 Enhancem.:

CR-2002-07-19-0: Bugfix:    fixed broken build for some architectures 
                            (CR-2002-07-18-4)

JG-2002-07-19-0: Doc:       updated qmake manpage to reflect usage of the
                            ARCH environment variable.
                 Changed:   man/man1/qmake.1           

JG-2002-07-18-0: Bugfix:    qsh mechanism passing options to xterm was broken.
                            help output for qrsh and qlogin contained 
                            unsupported options.
                 Changed:   qsh           

AS-2002-07-18-1  CVS        Created V531_beta3_TAG
--------------------------------------------------

CR-2002-07-18-4: Bugfix:    i18n new gridengine.pot file

CR-2002-07-18-1: Bugfix:    i18n wrong function call in infotext binary -
                            l10n not working
                 Bugtraq:   #4715919

CR-2002-07-18-0: Bugfix:    i18n aimk compilation for SOLARIS86 did not
                            translate i18n code

AA-2002-07-15-0: Bugfix:    l10n wrong widget name in qmon_cluster.ad file
                            dist/locale/en/qmon_messages.ad added as l10n
                            translation template

EB-2002-07-11-0: Bugfix:    qacct displays incorrect accounting information
                 IZ:        #314
                 Bugtraq:   #4713013
                 Changed:   qacct

AH-2002-07-10-4: Enhancem.: Further improved load alarm/suspend alarm
                            diagnosis messages
                 Changed:   sge_schedd

AH-2002-07-10-3: Bugfix:    Fixed problems with global load values
                            preventing job dispatching
                 Changed:   sge_qmaster
                 IZ:        #311
                 Bugtraq:   #4712023
                            
CR-2002-07-09-1  Testsuite: - added new SGE/SGEEE version strings for
                              5.3.1beta2 and SGE_5.3p1
                 Enhancem.: - new check "functional/job_environment" testing
                              job environment variables (e.g. JOB_NAME)
                 IZ:        #267     

CR-2002-07-09-0  Bugfix:    removed double conf_version lines when creating
                            local configuration in install script inst_sge

CR-2002-07-08-0  Enhancem.: I18N : modified Makefiles for lost lib_messages
                                   fixed infotext_msg_parse.tcl script  

AA-2002-07-08-0  Enhancem.: I18N : fontlist converter for mb locales
                                   not complete, Qmon.i18n added

EB-2002-07-04-0: Doc:       renamed "job array" to "array job" in
                            the manual pages
                 Changed:   qacct.1 qdel.1 qhold.1 qmod.1 qrls.1 qstat.1 
                            submit.1 accounting.5 sge_conf.5

CR-2002-07-04-1  Enhancem.: I18N : removed redefined message macro
                                   definitions (part 2)

CR-2002-07-04-0  Enhancem.: I18N : added message ids (part 1)


AS-2002-07-04-2  CVS        Created V53p1_rc1_TAG and V53p1_rc1_BRANCH
----------------------------------------------------------------------

AH-2002-07-02-2: Bugfix:    Fix problem with flittering load adjustment
                 IZ:        #309
                 Bugtraq:   #4710514
                 Changed:   sge_schedd

JG-2002-07-02-0: Bugfix:    qrsh -inherit failed with error 
                            "COMMPROC ALREADY REGISTERED"
                 IZ:        #303
                 Changed:   qsh

AH-2002-07-02-0: Bugfix:    Added missing newline character to error msg.
                 Changed:   qstat, qconf
                            
AH-2002-06-27-0: Enhancem.: Improved load alarm/suspend alarm diagnosis 
                            messages
                 Changed:   sge_schedd
                            
CR-2002-06-26-0: Testsuite: - new default parameter for wait_for_jobpending()
                              (return if job is already started)  
                 Enhancem.: - changed timeout values for access_list and
                              project_acces_lists test   

CR-2002-06-25-1: Bugfix:    script syntax error in exec host installation
                 IZ:        #297
                 Bugtraq:   #4705893

AA-2002-06-19-0: Change:    i18n gettext build script

CR-2002-06-17-2: Bugfix:    removed old i18n setup code

CR-2002-06-17-1: Bugfix:    Don't produce infotext error message "Binary not
                            compiled with gettext!"

AA-2002-06-14-0: Bugfix:    Job dependency display in qmon (not displayed)
                 IZ:        #275
                 Bugtraq:   #4706929
		 Changes:   qmon

CR-2002-06-13-5: Testsuite: testing issue #140 also for pending jobs
                 Enhancem.: 

JG-2002-06-13-0: Enhancem.  qtcsh: If a command is started in the background 
                            using qrsh, the qrsh option -nostdin is used to 
                            avoid qrsh being suspended.
                 IZ:        #287
                 Bugtraq:   #4701640

CR-2002-06-13-4: Testsuite: merged qrsh test for hold_jid and h option from
                            maintrunc

CR-2002-06-13-3: Testsuite: enhanced qstat test for -l/-q/-pe/-U option tests
                 IZ:        #286

AH-2002-06-12-0: Bugfix:    Prevent use of soft requests for consumables.
                            This addresses problems related to IZ #223 / BT
                            #4700286.  However it does not introduce
                            debitation for soft resource requests.

CR-2002-06-12-0: Testsuite: new testsuite checks (merge from MT)
                 IZ:        #140
                 IZ:        #141
                 IZ:        #171

EB-2002-06-11-0: Bugfix:    qstat shows waiting jobs of other PEs
                 IZ:        #284
                 Bugtraq:   #4699665
                 Changed:   qstat

AH-2002-06-10-0: Bugfix:    Complex default value was not used for load
                            thresholds in cases when no load value was
                            available.
                 IZ:        #223
                 Bugtraq:   #4700286

EB-2002-06-07-0: Bugfix:    disallow "none" in load_formula and addition
                            tests for the correctness
                 IZ:        #215
                 Bugtraq:   #4673738
                 Changed:   sge_qmaster

AH-2002-06-05-0: Bugfix:    Prevent qalter -l res=val on running jobs for 
                            consumable resources to prevent corruption of 
                            consumable managment 
                 IZ:        #251
                 Bugtraq:   #4683852

JG-2002-06-06-0: Bugfix:    Building Grid Engine with shared libs was broken. 

AH-2002-06-05-0: Bugfix:    Fix problem with notify mechanism causing actual 
                            termination/suspension signal being delayed 
                            endlessly
                 IZ:        #231
                 Bugtraq:   #4697491

JG-2002-06-05-2: Bugfix:    qsub allowed submission of binary files
                 IZ:        #247
                 Bugtraq:   #4696768

JG-2002-06-05-1: Bugfix:    Error handling when reading configuration at
                            qmaster startup was incomplete and produced
                            confusing error messages.
                 IZ:        #226
                 Bugtraq:   #4665780

AS-2002-06-05-2: Change:    print edit comment when cluster config is
                            created in inst_sge script
                 IZ:        #213

JG-2002-06-05-0: Bugfix:    Load values on HP-UX 11 multiprocessor machines 
                            were incorrect.
                 IZ:        #246

SD-2002-06-04-0: Bugfix:    Removed max_jobs reference from 5.3 branch
                 IZ:        #273
	              Bugtraq:   #4696766

SD-2002-06-03-0: Bugfix:    Fixed GRD 5.1.9 to SGEEE 5.3 upgrade
		 IZ:   	    #273
                 Bugtraq:   #4696766

JG-2002-05-31-0: Enhancem.  rshd: new switch -i: ignore /etc/nologin
                 IZ:        #272
                 Bugtraq:   #4708235

AH-2002-05-29-0: Bugfix:    Fix bug allowing non-privileged users to submit
                            jobs with priority higher than 0
                 IZ:        #271
                 Bugtraq:   #4692957

JG-2002-05-29-0: Enhancem.  Allow specification of arguments to 
                            [rsh|rlogin|qlogin]_[daemon|command]
                 IZ:        #232
                 Bugtraq:   #4708239

AH-2002-05-28-0: Bugfix:    Fix messages printed when GDI client fails
                            contacting qmaster

JG-2002-05-27-0: Bugfix:    qsh ignored -S <shell> in sge_request(5) files
                 IZ:        #250
                 Bugtraq:   #4682966

AA-2002-05-27-0: I18N.:     I18N/L10N changes

CR-2002-05-23-1: Enhancem.: Testsuite update of install_core_system check:
                            new messages for L10N caused timeouts.

AA-2002-05-23-0: Bugfix:    qmon_messages.ad for l10n 

CR-2002-05-22-3: Bugfix:    infotext message output on linux

CR-2002-05-22-2: Bugfix:    infotext binary

CR-2002-05-22-1: Enhancem.: New script for i18n: Extract messages from
                            install scripts (file:
                            source/scripts/infotext_msg_parse.tcl)

CR-2002-05-22-0: Enhancem.: added "infotext" binary for l10n 

JG-2002-05-22-0: Doc:       Fixed description of the environment variable 
                            SGE_TASK_ID for non array jobs in submit man page.

JG-2002-05-21-0: Bugfix:    Recycling of additional group ids did not respect 
                            tightly integrated pe tasks.
                 IZ:        #263

CR-2002-05-21-0: Bugfix:    smaller bugfixes for infotext binary

CR-2002-05-16-0: Enhancem.: - i18n changes for inst_sge (part 1)
                            - renamed sge_printf into "infotext"
                              (INteractive Formatted lOcalized TEXT)
                            - added infotext features
                              (-wait -auto -ask options)
                            - MERGED FROM MAINTRUNC
                            - added dstring modules

EB-2002-05-06-0: Bugfix:    qhost -j is broken
                 IZ:        #259
                 Bugtraq:   #4686157
                 Changed:   qhost

CR-2002-05-14-0: Change:    removed sge_printf build from Makfile 

CR-2002-05-13-0: Enhancem.: added sge_printf utilbin source files

AH-2002-05-13-0: Change:    Do no longer flush events immediately after
                            orders arrival to 'guarantee' scheduling is done
                            not more often than specified with
                            schedule_interval in sched_conf(5).
                 Changed:   sge_qmaster

EB-2002-04-13-0: Bugfix:    qconf -se shows "reschedule_unknown_list" param. 
                 Issues:    #248 
                 Changed:   sge_qmaster, qacct, qconf

CR-2002-05-06-0: Testsuite: fixed check dependencies

AH-2002-05-06-0: Bugfix:    Fix typo in simple.sh job example

CR-2002-05-03-0: Testsuite: - removed rsh with rlogin calls
                            - compile source has set wrong LIBPATH on AIX
                            - timeout setting changed for some tests
                            - additional cleanup for some tests
                            - added more error output 
                            - new parameter for create_shell_script(),
                              start_remote_prog(), open_remote_spawn_process()
                              (source_settings_file parameter)
                            - new procedure: get_submit_error(): 
                              resolve submit error value

JG-2002-04-30-1: Enhancem.: Contribution of Guiseppe Palumbo: Make the
                            ibm-loadsensor script work with AIX 5.1.0

JG-2002-04-30-0: Bugfix:    Buffer for task_id of pe task was too small.
                            This could cause a buffer overflow and probably
                            crashes of execd.
                 IZ:        #299           
                 Bugtraq:   #4677087    
                 Changed:   sge_execd           

EB-2002-04-29-1: Bugfix:    schedd bugs reported by Patrik Koch
                            on dev mailing list (Mon, 15 Apr 2002) 
                            - Memory leak
                            - potential wrong job state handling
                 Issues:    #243
                 Bugtraq:   #4676340 
                 Changed:   sge_schedd

AH-2002-04-29-0: Change:    In the sched_conf(5) man page it was wrongly 
                            documented that the maxujobs setting is only in 
                            effect when the user_sort policy is activated and 
                            that it is not available at all in a SGEEE system. 
                            Furthermore it was wrongly documented that the 
                            maxujobs limitation is applied separately to each
                            priority group.
                 IZ:        #249
                 Bugtraq:   #4681454 

AH-2002-04-26-0: Bugfix:    - queue nsuspend > 1 was not used to suspend
                              multiple jobs in a queue at a time in case of a
                              suspend threshold alarm.
                 IZ:        #239
                 Bugtraq:   #4675410
                            - use of suspend thresholds and user sort policy
                              could cause "inconsistent access tree data" schedd
                              logging and break user sort policy
                 IZ:        #240
                 Bugtraq:   #4675416
                 Changed:   sge_schedd

CR-2002-04-25-1: Testsuite: - access_list test:
                              -> submit jobs with 30 sec instead of 15 secs
                                 due to evtl. timeout problems
                            - path_alias test:
                              -> using tcl command dirname to resolve the
                                 directory path due evtl. double existing
                                 path slashes


CR-2002-04-25-0: Testsuite: - checking compile hosts on setup
                            - project_access_lists test: 
                              -> do not wait for jobs with negative job id!
                            - remote_procedures.tcl:
                              -> return without spawn_id if host is not
                                 reachable or if shell can't be started!
                            - sge_procedures.tcl:
                              do a qconf -tsm before getting schedd info
                            

CR-2002-04-24-0: Testsuite: - creating CHECK_PRODUCT_ROOT directory if it
                              is not existing on setup()
                            - procedure gethostname -> try to get hostname
                              from a local installed hostname call or from
                              user's HOST environment variable if GE's
                              gethostname isn't available. (before compiling)

CR-2002-04-23-0: Testsuite: merged compile procedure enhancments from
                            maintrunc

JG-2002-04-19-0: Bugfix:    Interactive jobs of any user failed if root had 
                            already the maximum number of group id's.
                 Enhancem.: More detailed description in error output
                 IZ:        #237
                 Bugtraq:   #4670669
                 Changed:   sge_shepherd qsh rshd

JG-2002-04-18-1: Enhancem.  Improved verbose output in qmake.
                            Start tasks on localhost also per qrsh - slower, 
                            but tasks are identifiable in accounting

JG-2002-04-18-0: Bugfix:    If more then 1 task of a parallel job was started
                            in a queue, retrieving exit code of a task and
                            signaling a task was unreliable as the TASK_ID
                            variable was no longer exported to the tasks 
                            environment. Replaced the TASK_ID mechanism by
                            an entry in the jobs config.
                 IZ:        #236
                 Bugtraq:   #4670664
                 Changed:   sge_shepherd, sge_execd, qrsh_starter

CR-2002-04-17-0: Testsuite: fixed tcl error on using help command line
                            parameter

JG-2002-04-16-0: Enhancem.: In simulation mode (qmaster_param simulate_hosts=1)
                            one qsub call can submit any number of identical 
                            jobs by setting the job context variable 
                            SGE_MULTI_SUBMIT to the number of jobs to be 
                            created.

CR-2002-04-12-1: Bugfix:    corrected spelling mistakes

CR-2002-04-11-5: Testsuite: (merge from maintrunc)
                            - only produce warning when re_init core 
                              system resets cluster/schedd configuration
                            - removed DEMO category
                            - new interactive menu points:
                              (23) compile and pre install binaries
                              (24) compile and pre install, then install 
                                   and run not completed tests
                              (25) set testsuite debug level


CR-2002-04-11-3: Testsuite: Merge of CR-2002-04-11-2, CR-2002-04-11-1 and
                            CR-2002-04-11-0 from maintrunc

EB-2002-04-11-0: Bugfix:    Solaris processor sets / Migration script
                            - fix: solaris psets won't be used
                            - fix: checkpointed job migration on bad exit state
                 IZ:        #229, #174
                 Bugtraq:   #4668148
                 Changed:   sge_shepherd

JG-2002-04-11-0: Bugfix:    In simulation mode, job reports were not flushed 
                            at (simulated) job end.

JG-2002-04-08-0  Bugfix:    qrsh -h did debug output (a job object).
                 Changed:   qrsh

CR-2002-04-08-0  Bugfix:    Fixed compiler warning in ptf.c

CR-2002-04-05-0  Testsuite: Merges from maintrunc

JG-2002-04-05-0  Testsuite: large_cluster_test: Do not use the qmaster host
                            as exec host for simulation of hosts.

SD-2002-04-03-0  Feature:   merges from V53_beta2_sx6_BRANCH
                            SX architecture updates
                            - Support dynamic setting of timeslice values
                            - Set execd to high priority to prevent swapping
                            - Only set # of processes limit for job
                            - Updated SX checkpoint scripts
                            - Renamed "necsx5" architecture to "sx"
                            - Set resource limits after setting the OS
                              job id in builtin_starter.c so that job
                              resource limits will work on the SX-6.
                            Added support to control restart timeout
                            delays using environment variables.

JG-2002-04-02-0  Testsuite: Fixed problems when creating HTML charts
                            in large_cluster test.

CR-2002-03-28-2  Testsuite: merges from maintrunc
                            - new menu point: check messages files of
                              execds and qmaster
                            - new tcl file procedure: get_file_content()
                            - new sge procedure: check_execd_messages()
                            - new sge procedure: check_qmaster_messages()
                            - new sge procedure: check_messages_files()
                            - added new version: "SGEEE pre6.0 (Maintrunk)"
                            - added new version: "SGE pre6.0 (Maintrunk)"

JG-2002-03-28-2: Testsuite: - sge_procedures: new functions shutdown_qmaster, 
                              shutdown_scheduler and startup_scheduler.
                            - large_cluster test: shutdown scheduler before 
                              initializing new test to get time for first 
                              scheduling.

AS-2002-03-28-0: CVS:       Created V53_TAG --> SGE 5.3
-------------------------------------------------------

JG-2002-03-28-1  Testsuite: Create HTML output after each run level.

JG-2002-03-28-0  Testsuite: large_cluster test: submit jobs in parallel from
                            multiple hosts.

AH-2002-03-27-0  Enhancm.:  Increased GRM_GDI_VERSION to ensure 5.3
                            components cleanly refuse interoperating with
                            5.3 beta2 components

AS-2002-03-27-0  Install:   cleanup install details in for "distinst"

JG-2002-03-27-0  Testsuite: large_cluster test:
                            - fixed problems due to change of runlevel
                            - output cluster utilization in test report

CR-2002-03-27-0  Bugfix:    Fixed broken shadow daemon qmaster startup
                            functionality

SD-2002-03-26-1  Bugfix:    Fixed "missing node XXXXX in dst trees" problem
                            where a temporary share tree node was being sent
                            to qmaster

AH-2002-03-26-0  Bugfix:    Found and fixed infinite loop in commd in case
                            host formerly resolved by gethostbyname(3) is no
                            longer resolvable. Also fix commd option -dhr
                            which was -drh before.
                 Bugtraq:   #4658193
                 IZ:        #212

JG-2002-03-26-1  Bugfix:    At startup qmaster removed pending messages too
                            late (after daemonizing instead of after
                            enrolling).  In rare cases (starting schedd
                            immediately after qmaster daemonized on a fast
                            machine) this could produce an error and cause a
                            delayed registration of the scheduler.

CR-2002-03-26-2  Bugfix:    - wrong error handling if qmaster is down and
                              user tries qdel -f 
                            - changed code formating

JG-2002-03-26-0  Testsuite: Installation with many hosts did not work due to
                            some buffer (commandline?) being too small.
                            Pass hostnames to install_qmaster in a file.

CR-2002-03-26-1  Bugfix:    qstat -f -> 8 x times logging: "... neither
                            submit nor admin host"

CR-2002-03-26-0  Bugfix:    can't resolve hostname "%-.100s" from
                            act_qmaster file message

AH-2002-03-25-0  Bugfix:    gethostbyname -aname was broken
                 Optimiz.:  Ensure global conf is read only one time by
                            AH-2002-03-22-0 code

JG-2002-03-25-0  Testsuite: Bugfix: In a cluster with very similar hostnames
                            testsuite wrongly reused open remote
                            connections.

AS-2002-03-22-0  Change:    reresolve_me_qualified_hostname() does not log
                            anymore. Calling functions now do appropriate
                            logging.

CR-2002-03-22-2  Bugfix:    qacct output formatting

AA-2002-03-22-3  Bugfix:    sharetree position of FindNext not visible fix

CR-2002-03-22-1  Bugfix:    Enhancements for CR-2002-03-22-0
                 IZ:        #158

AA-2002-03-22-2  Bugfix:    Tru64 spinbox incrementLarge fix for cluster
                            config dialogue

CR-2002-03-22-0  Bugfix:    Reopend issue: Wrong error message when service
                            sge_commd is not available
                 IZ:        #158

AH-2002-03-22-0  Bugfix:    Ensure shepherd mapping signals do not hit
                            shepherd itself because of signal handler not
                            installed when signals are released by
                            sigprocmask(2)

AH-2002-03-22-0  Bugfix:    Retrieve ignore_fqdn and default_domain at
                            client/daemon startup from global cluster config
                            to overcome problems with hashing of hostnames
                            in certain cases.

AA-2002-03-21-1  Bugfix:    sorting in functional/override policy,
                            fix for not emptying matrix

AA-2002-03-21-0  Bugfix:    SGE_KEYFILE, SGE_CERTFILE 
                            sec install scripts

CR-2002-03-21-4  Bugfix:    scheduler generates high CPU load for 1-2
                            minutes when sge_commd is killed.
                 IZ:        #197

EB-2002-03-21-2  Bugfix:    remove old configuration (EB-2002-03-21-0)

CR-2002-03-21-3  Testsuite: - used wrong path in path_alias test
                 Bugfix:    - don't use shepherd wrapper script (code is
                              just out commented for later reuse)

EB-2002-03-21-1  Enhancem.: sort output of qconf -sep

CR-2002-03-21-2  Bugfix:    changed error messages when master commd is not
                            reachable.

CR-2002-03-21-1  Bugfix:    removed forgotten #if0 - #endif statement which
                            chauses scheduler to abort() on testsuite's 
                            path_alias check.

JG-2002-03-21-0  Bugfix:    prioritization of messages to qmaster could
                            block reports from execd's to qmaster and make
                            the system unusable.
                            Set "no prioritization" as default, behaviour
                            can be changed via env variable
                            SGE_PRIORITY_TAGS.

EB-2002-03-21-0  Bugfix:    local config not written as admin user at
                            startup
                 IZ:        #198

CR-2002-03-21-0  Testsuite: merge from maintrunc
                            sending "vt100" when client host is using tset
                            for terminal settings.

AA-2002-03-20-0  Bugfix:    qhost formatting

EB-2002-03-20-1  Bugfix:    can't receive request: READ ERROR
                            - replaced closeconnection(0) calls within 
                              recvfromcommd() through closeconnection(1) calls 
                              in case of read error
                            - improved logging; additional messages may be 
                              found in the messages files of the daemons which 
                              might help if these errors occure again
                 IZ:        #176 (partially)

EB-2002-03-20-0  Cleanup:   removed global variable monitor_next_run

JG-2002-03-20-1  Bugfix:    Check return code of fclose in spooling functions
                            and handle error situations:
                            - log critical error
                            - remove file
                 IZ:        #185

CR-2002-03-20-0  Bugfix:    qselect/qstat -U is (partially) broken
                 IZ:        #191

JG-2002-03-20-0  Bugfix:    Reduce memory consumption of qmaster and size of 
                            spool files for tightly integrated parallel jobs 
                            that start series of tasks per slot reserved 
                            (e.g. qmake). 

AS-2002-03-19-0  Install:   openssl command not required if not "-csp" mode

AA-2002-03-19-4  Bugfix:    - scripts for I18N, gettext-1.11

AA-2002-03-19-3  Bugfix:    - qmon cluster_token_extend_time was lost

AA-2002-03-19-2  Feature:   - install doc for CSP

AA-2002-03-19-1  Bugfix:    - STN_type sharetree read from disk
                            - qmon Sharetree Find fix scrollbars

CR-2002-03-19-1  Testsuite: - stop install_core_system check if qmaster 
                              is not reachable after installing last execd
                            - shutdown_core_system(): only try to use root
                              access if password is available

CR-2002-03-19-0  Bugfix:    Fixed broken build on IRIX6 arch

CR-2002-03-18-1  Bugfix:    Mail on suspend wasn't working
                 IZ:        #86
 
                 Bugfix:    Wrong error message when service sge_commd 
                            is not available    
                 IZ:        #158


AA-2002-03-18-3  Legal:     Xmt copyrights

AA-2002-03-18-2  Bugfix.:   cluster config sensitivity grey labels

EB-2002-03-18-0  Enhancem.: Modifications for redhat 7.2 (gcc 2.96) 

CR-2002-03-18-0  Testsuite: - qdel check:
                              1) clear all error states on test cleanup
                              2) leave test loop on job submission error
                            - new version numbers: SGEEE_5.3beta2_2 and
                                                   SGE_5.3beta2_2
 

AA-2002-03-18-1  Bugfix:    - STN_type field is set to display sharetree nodes
                            correctly
                            - Clear Usage
                            - shellstart mode fix in qmon
                            - logo update /off_home/codine/sun-copyright
                            - why crash fix
                            - interactive mode fix
                            - global host first
                            - project itemlist sorting

AA-2002-03-18-0  Bugfix:    sge_ca script, check /dev/random 1st

AH-2002-03-15-4  Bugfix:    Ensure after execd installation the host needs to be 
                            only exec host but not admin host or submit host

EB-2002-03-15-0: Bugfix:    qmaster code accepted qsub -t task specification
                            which included the id 0 => loop in schedd
                 IZ:        #192

AS-2002-03-15-1  Install:   ignore_fqdn accidentially always set to true
                            remove qlogin_command from default local config

AS-2002-03-15-0  Install:   unset CODINE_ROOT, GRD_ROOT in inst_sge
                            add /usr/bsd to PATH for "clear" command on SGI
                            in various scripts in util/
                            enhance "sgemremoterun" and "install_cluster.sh" 
               
AH-2002-03-15-2  Doc:       Added information about qmod [-e|-s|..] queue_list
                            syntax (wildcards).

AH-2002-03-15-0: Bugfix:    Changed scheme used for creation of id used for 
                            qrsh -inherit sub-tasks to fix accounting data leak with 
                            multiple runs of a par. application within a job. Also
                            write id into accounting file.
                 Bugtraq:   #4447392

AA-2002-03-14-0: Bugfix:    msg_sec.h new messages

EB-2002-03-13-0: Bugfix:    handling of faulty migrate script
                            - improved logging
                            - shepherd internal state will be reset. 
                              Further migrate requests will be initiated
                 IZ:        #146 (partially)

JG-2002-03-13-0  Doc:       Improved the qmake man page to reflect the 
                            necessity to use the options -v PATH and -cwd.

AA-2002-03-11-0: Bugfix:    Save Setting, Clear functionality bugs 

AS-2002-03-11-2: CVS:       Created V53_beta2_2_TAG
---------------------------------------------------

AA-2002-03-11-0: Bugfix:    removed qs_args from qmon

AS-2002-03-11-1: Doc:       added "doc/logfile-trimming.asc" to document
                            behavior of "util/logchecker.sh".

AS-2002-03-11-0: Enhancem.: added "util/logchecker.sh" script to truncate/rotate 
                            'messages' files

AH-2002-03-11-0: Bugfix:    A set of fixes on initiative from Patrik Koch

AS-2002-03-08-2: Doc:       document location of PE stderr/out files in
                            qsub(1) and sge_pe(5)
                 IZ:        #94

AS-2002-03-08-0: Change:    set version string to "5.3beta2_2"

JG-2002-03-08-0  Testsuite: Make testsuite work for users that use a csh as
                            login shell (open_remote_spawn_process).

AA-2002-03-07-0: Bugfix:    Addition of acl to project generated core dump due
                            to uninitialized pointer

EB-2002-03-07-1: Bugfix:    Array Tasks, inconsistent handling of multiple
                            task ranges
                 IZ:        #49 

EB-2002-03-07-0: Bugfix:    inconsistences between qstat/qmon output and
                            internal state
                 IZ:        #179 

EB-2002-03-06-1: Doc.:      Added documentation for (auto)rescheduling
                            - removed RESCHEDULE_UNKNOWN from sge_conf
                            - added reschedule_unknown to sge_conf
                            - added r to when attribute of checkpoint
                            - changed qsub -m doc.
                            - added doc. for qmod -r  

JG-2002-03-06-0: Doc.:      Enhanced description of execd_params
                            SET_[SGE|COD|GRD]_ENV.
                 IZ:        #120

AH-2002-03-05-0: Doc.:      Fixed description of seq_no queue parameter 
                            in queue_conf(5). 
                 Bugtraq:   #4490117
                        
CR-2002-03-05-0: Testsuite: - sge/ee installation path (product root) should
                              not be longer than 60 chars ( workaround, because
                              output of ps -ef command is truncated on some
                              machines )
                            - fixed error in path_alias test: automounter 
                              /tmp_dir/ problem !
                            - submit_del (signal) test did not clear 
                              queues in error state at cleanup 
                            - modified error output in 
                              shutdown_master_and_scheduler() procedure
                            - all items merged from maintrunc

CR-2002-03-04-1: Bugfix:    hostname resolving check was executed even when
                            ignore_fqdn = true was set.


EB-2002-03-04-2: Bugfix:    'qdel <array-jid>' might cause qmaster core
                            depending on the tasks history.
                 IZ:        #173  

CR-2002-03-04-0: Bugfix:    qacct truncates project/department/... names 
                            (merge from maintrunc)
                 IZ:        #150

AH-2002-03-04-2: Enhancem.: Added PVM 3.4.4 Virtual Machine ID setting
                            to startpvm.sh from Andrew Shewmaker


EB-2002-03-04-1: Bugfix:    'qalter -h xxx' caused core if task of array
                            did not exist.
                 IZ:        #171 

EB-2002-03-04-0: Bugfix:    schedd_runlog file was not written by a
                            'qconf -tsm' command  
                 IZ:        #170

EB-2002-03-01-1: Bugfix:    inconsistences between qstat and qmon output
                 IZ:        #148

CR-2002-03-01-0: Testsuite: - using source/dist/util/arch from source directory
                              and not from product_root/util/arch. This 
                              prevents errors on testsuite first setup call. 

CR-2002-03-01-0: Testsuite: - runlevel of large_cluster performance test set to
                              300++ ( day )

EB-2002-03-01-0: Bugfix:    "scheduler tries to schedule xxx twice" logging in 
                            qmaster
                 IZ:        #167

CR-2002-02-28-1: Testsuite: (MERGED from maintrunc)
                 Enhancem.: - new test: system_tests/sheperd/submit_del
                              testing sheperd signaling with sheperd wrapper
                              script.
                 IZ:        #125  (Part 1)
                 Bugfix:    - fixed typo in system_tests/clients/qdel
                            - removed unused var system_tests/shadowd/migrate

CR-2002-02-28-0: Testsuite: (MERGED from maintrunc) 
                 Bugfix:    - wrong error message in wait_for_end_of_all_jobs()
                 Enhancem.  - submit_job() generates output for timeout and eof
                              error
                 Enhancem.  - 2 new parameters for create_shell_script()

JG-2002-02-27-0: Doc:       Documented the qrsh -noshell option in the
                            qrsh/submit man page.
                 IZ:        #132

EB-2002-02-26-1: Bugfix:    Fixed one problem repoted bye Patrik Koch.
                            - switched call order in
                              job_delete_not_enrolled_ja_task()

CR-2002-02-27-0: Bugfix:    Merged from maintrunc: a) removed unnecessary
                            feature_is_enabled() call in qmon_main.c
                                                   b) aimk LFLAGS

CR-2002-02-26-1: Testsuite: changes from maintrunc merged

CR-2002-02-26-0: Feature:   qmaster installation script will now check if
                            sge_qmaster binary is compiled with aimk -secure
                            when -csp option is used, otherwise installation
                            of qmaster will fail. (merged from maintrunc)


EB-2002-02-26-0: Enhancem:  Some modifications for EB-2002-01-23-1
                            - return value 25 for qrsh, qsh, qlogin, qresub
                            - modified man qubmit man page

JG-2002-02-26-0: Bugfix:    qlogin did no longer work for solaris exec hosts.
                 IZ:        #151

EB-2002-02-25-0: Bugfix:    - Error in qdel return message if task does not
                              exist
                 IZ:        #144 #161

AA-2002-02-25-0: Testsuite: changes from maintrunc merged

AA-2002-02-22-0: BUGFIX:    memleak fix in sec_lib.c 

EB-2002-02-18-0: Bugfix:    Attempt to unlink directory + bogus error message
                            - finished jobs have no task instanced
                              => do not create a directory
                              => put whole zombie job into one file
                                 $SGE_ROOT/default/spool/qmaster/zombies/ ... 
                                 ... xx/yyyy/zzzz (zzzz is a file)
                 IZ:       #149  

AS-2002-02-13-3: CVS:       Created V53_beta2_sx6_TAG and V53_beta2_sx6_BRANCH
------------------------------------------------------------------------------

AS-2002-02-13-3: CVS:       Created V53_beta2_1_TAG
---------------------------------------------------

AS-2002-02-13-2: Bugfix:    install "UPGRADE" file and shared libraries with
                            "mk_dist" and "distinst"

AS-2002-02-13-1: Enhancem.:  added README.inst_sgeee to SGE_ROOT to explain how to
                             install SGE as SGEEE

AS-2002-02-13-0: Change:    set version string to "5.3beta2_1"

EB-2002-02-12-0: Bugfix:    - step size will be ignored from qdel command
                            - qmaster will core if task id range comprises
                              not existing task at the end 

AS-2002-02-12-0: Bugfix:    Sun HPC installation script failed since default
                            queue type now is already PARALLEL

AS-2002-02-04-1: CVS        Created V53_beta2_Tag and V53_beta2_BRANCH
----------------------------------------------------------------------

AS-2002-02-04-0: Doc:       updated courtesy download pages to reflect
                            changes for Grid Engine 5.3beta2 download

CR-2002-02-04-0: Enhancem.: aimk -DNO_USER_MAPPING_AMBIGUOUS_IN_CHECK will
                            disable the user mapping check for incoming 
                            mapping requests.
                 IZ:        #129

JG-2002-01-30-2: Enhancem.: Higher precision for scheduler profiling.

JG-2002-01-30-1: Doc:       Updated qconf manpage to document options
                            -secl and -kec (see JG-2001-11-26-0).
                 IZ:        #100           

JG-2002-01-30-0: Doc:       Updated qconf manpage to document options
                            -Auser and -Muser (see JG-2001-11-08-1).
                 IZ:        #90           

CR-2002-01-29-2: Testsuite: create foreign user keys for secure system
           

CR-2002-01-29-1: Bugfix:    broken aimk -umap build
                 IZ:        #127

JG-2002-01-29-1: Doc:       Updated qconf manpage to reflect changes
                            from JG-2002-01-10-0.
                 IZ:        #115           

JG-2002-01-29-0: Testsuite: Enhanced "large_cluster" test:
                            - check product type (sge/sgeee)
                            - create HTML report with charts generated by 
                              gnuplot

EB-2002-01-29-0: Enhancem.: Improved logging
                            - product mode string will be printed during
                              startup and shutdown

CR-2002-01-29-0: Testsuite: - new settings file version "6" (new parameter
                              product_feature)
                 Enhancem.: - added support for secure SGE/EE system
                            - removed command line parameter test_perm
                            - added command line parameter reset_conf
                            - updated changes from install script
                            - testing product feature file on startup

AH-2002-01-29-0: Bugfix:    - scheduler had problems with iterating over PE slots range
                              from max to min in case of $pe_slots alloc rule

AA-2002-01-28-2: Feature:   - sge_ca -usercert <file> added to generate keys/certs for
                              users in file

EB-2002-01-28-0: Bugfix:    - "qselect -l h=<host with no queues>" prints
                              error message.

AA-2002-01-28-1: Bugfix:    - qmon unable to contact master message fix
                            - func proto show_info_job,..

AA-2002-01-28-0: Bugfix:    - GCC_NO_STRICT_PROT broke build on alinux
                              GCC_NO_STRICT_PROT -> GCC_NOSP in aimk and security/sec/Makefile
                            - memleak fixes in security/sec/sec_lib.c  

AS-2002-01-28-0: Change:    removed SECURE defined from CULL headers"

SD-2002-01-25-2: Bugfix:    Changed aimk variable name GCC_NO_STRICT_PROTO to
                             GCC_NO_STRICT_PROT variable because /bin/csh on the SX-6
                             only allows 18 character variable names.

AH-2002-01-25-1: Bugfix:    Removed last reference of no longer existing QSI from man pages.
                            The QSI functionality is replaced by {starter,terminate,suspend,
                            resume}_method functionality
                 Enhancem.: Default queue type is now batch, interactive and parallel.

EB-2002-01-25-1: Bugfix:    - shadowd did not remove the lock file
                              if it encountered that there may be another
                              master.
                 Enhancem.: - A shadowd which tries to start a new master
                              has to check whether the old one is still
                              enrolled at the old master commd.
                              If this is the case the shadowd has to wait
                              for another cycle.

AH-2002-01-25-0: Enhancem.: - fixed man page doc issues #31, #84, #85
                              * changes on -hold_jid accepting both jobid and jobname
                              * default location for Grid Engine host aliases file not descr
                              * qstat(1) does not explain meaning of 'd' state indicator

CR-2002-01-25-0: Bugfix:    changed some settings to prevent timeouts

EB-2002-01-25-0: Enhancem.: new schedd_param: POLICY_HIERARCHY

JG-2002-01-25-0: Enhancem.: If killing a qrsh <command> job (by the pid of the
                            qrsh_starter) is not successful (because the started
                            application left the process group) a second kill
                            request will kill the process group of the shepherds
                            child (the rshd) to ensure the job is terminated.

AH-2002-01-24-0: Enhancem.: - added 'maxvmem' as new per job usage information
                              in qmon and accounting 
                            - fix problem with wrong 'maxvmem' information
                              in job finish mail for non-pdc architectures
                            - ensure daemons log 'starting up'/'controlled shutdown'
                              messages independently of the configured log_level

SD-2002-01-24-4: Bugfix:    IRIX C compiler didn't like default: 
                            followed directly by a } in a switch
                            statement.

AA-2002-01-24-3: Bugfix:    coshepherd Makefile SLIBS was missing

EB-2002-01-24-2: Bugfix:    Typo: NO_REPRIORIZATION -> NO_REPRIORITIZATION

AA-2002-01-24-2: Feature.: sge_ca permission problem for daemon cert fixed

AA-2002-01-24-0: Feature.: sge_ca -copy to install user cert and key

CR-2002-01-24-0: Enhancem.: updated install script (inst_sge) changes

JG-2002-01-24-3: Bugfix:    Scheduler profiling could not be switched off
                            at runtime once it was enabled.

EB-2002-01-24-1: Bugfix:    Give other clients (gdi requests) the chance to
                            be handled by the commd before 
                            we send a next request of a fragmented qdel 
                            request.

JG-2002-01-24-2: Bugfix:    np_load_avg was not correctly computed for multi
                            processor machines.

EB-2002-01-24-0: Bugfix:    Fixed "bug" within the code handling task id
                            ranges which caused performance problem
                            in scheduler for huge fragmented array jobs
                            and array jobs with a step size != 1.

AS-2002-01-24-2: Enhancem.  added SUN MPI install support for 'distinst'"

AS-2002-01-24-1: Enhancem.  Added PE 'make' template

AS-2002-01-24-0: Enhancem.  Added SUNHPC loose integration package

AA-2002-01-24-0: Feature:   Security:
                            - sge_ca script changes: rand file generation
                                                   check of dn
                            - rand file search paths
                            - GCC_NO_STRICT_PROTO for alinux

JG-2002-01-24-1: Testsuite: New test "large_cluster" testing performance and
                            scalability of a Grid Engine cluster.
                            Simulating a large cluster using the simulation
                            mechanisms provided by JG-2002-01-18-0. 
                            Tests performance dependent on 
                            - number of hosts and number of jobs
                            - number of hosts and size of a sharetree (GEEE)

JG-2002-01-24-0: Testsuite: New functions in sge_procedures:
                            - add_exechost: add an exec host object
                            - add_user    : add a user (GEEE)
                            - del_user    : delete a user (GEEE)

AS-2002-01-23-1: Enhancem.  set execd priority not higher than PTF_MAX_PRIORITY

SD-2002-01-23-3: Bugfix:    Fixed setting of shared override tickets in
                            SGEEE_CLASSIC_SCHEDULING mode.

EB-2002-01-23-1: Enhancem.: max_u_jobs parameter to limit the maximum number
                            of jobs for a user.

EB-2002-01-23-0: Bugfix:    qsub -e/o <path longer than MAX_STRING_SIZE>
                            caused crash of qmaster

SD-2002-01-23-2: Bugfix:    Initialize rusage structure to zeroes

AS-2002-01-23-1: Enhancem.  set execd priority not higher than PTF_MAX_PRIORITY

AA-2002-01-23-1: Feature:   Security:
                            - fallback key/cert paths
                            - removed gsd.refresh_time debug message

CR-2002-01-23-1: Testsuite: - new procedure: close_open_rlogin_sessions()
                 Enhancem.: - closing all rlogin sessions on TCL error
                            - send CTRL + C on each close_spawn_process() call
                              to stop evtl. running applications at remote host          
CR-2002-01-23-0: Testsuite: - updated resolve_version for SGE(EE) 5.3beta2
                            - bugfix for SGE installation (install_core_system)

AA-2002-01-23-0: Feature:  Security:
                           - change of cert/key paths
                           - sge_security_ck_to_do() added
                             kerberos and CSP sec funcs now in module
                             libs/gdi/sge_security.c
                           - clearance of connectionlist changed

CR-2002-01-22-0: Testsuite: - install_core_system check will now use default
                              values for most all cluster configuration setup 
                              and report configuration changes through sge_inst 
                              script
                            - re_init cluster after tcl_error will now restore
                              cluster configuration for most parameters

AS-2002-01-21-2: Feature:  updated version and GDI version

AS-2002-01-21-0: Bugfix:   fixed typo in scripts/distinst

JG-2002-01-22-0: Bugfix:    Tight integration using the mpi scripts: 
                            starting a task from within a task failed, as the 
                            environment variable TASK_ID was exported to the 
                            second level qrsh call and qrsh tried to allocate
                            this TASK_ID a second time.

CR-2002-01-21-1: Testsuite: - setup checking length of product_root_directory
                            - setting default load_thresholds to "np_load_avg=11.00"
                            - Bugfix in submit hosts test 
                            - Bugfix for sharetree test (no timeout behavior
                              for CLASSIC_SGEEE_SCHEDULING case)

CR-2002-01-21-0: Testsuite: - changed menu point 9 ( run all tests at 
                              a special starttime)
                 Enhancem.: 

SD-2002-01-18-2: Enhancem.  Minor PTF fix for setting nice values on NEC SX-6

EB-2002-01-18-1: Bugfix:    - qalter of job name caused core of master

JG-2002-01-18-0: Enhancem.  Simulation mode for large clusters.
                            When the qmaster_param simulate_host=1 is set,
                            a cluster with a high number of hosts can be 
                            simulated. 

EB-2002-01-18-0: Bugfix:    - reactivated qdel output for already deleted jobs
                            - enabled signalling for already deleted jobs

CR-2002-01-18-1: Testsuite: - general performance modified cluster configuration
                 Bugfix:      without restoring it.

CR-2002-01-18-0: Testsuite: - new command line parameter: re_init_on_tcl_error
                 Enhancem.:   (if set the testsuite will do a install re_init 
                               before starting the next test)
                            - extend timeout values in submit_hosts check

AA-2002-01-17-1: Bugfix:    - qmonMirrorMultiAnswer
                            - I18N in qmon

CR-2002-01-17-1: Testsuite: - submit_job():
                 Enhancem.:     new error state -13 for unkown option error
                 Bugfix:    - fixed broken file_parsing test
                            - source of tcl files at startup of each test

CR-2002-01-17-0: Bugfix:    ERROR(()) call without string limitation "SFQ"
                            in execd caused segmentation fault when job
                            name length >  (ca.) 2K byte

EB-2002-01-17-0: Enhancem.: Improved logging of shadowd

AA-2002-01-17-0: Feature:   Security:
                            - cert scripts

JG-2002-01-16-0: Enhancem.: Execd can send load values for another host than
                            itself and qmaster will accept these load values.
                            Simulation mode to make qmaster not trash load
                            values for simulated hosts can be switched on
                            by qmaster_param simulate_hosts=1.
                            Performance improvement: Execd deliveres info
                            whether a variable is static or not.

CR-2002-01-16-1: Testsuite: - fixed broken migration test
                 Bugfix:    - fixed broken job_state_handling test
                            - new optional parameter for submit_job(): 
                                cd_dir: set working directory

EB-2002-01-15-0: Enhancem.: per user namespace for job dep. names

CR-2002-01-16-0: Testsuite: - faster lockfile check
                            - new settings file version: 5
                                (new foreign users/group setup)
                            - syntax check for testsuite users/group setup
                            - set_exechost(): ignore unchangable values
                            - submit_job(): new error states for access errors
                            - get_qstat_j_info(): joining lines, containing no ":"
                                 in order to get complete scheduling info
                            - new procedure: get_scheduling_info()
                            - new procedure: add_access_list()
                            - new procedure: del_access_list()
                            - job_state_handling test: 
                                 using new procedure get_scheduling_info()
                            - qrsh test:
                                 update for defaults file changes
                            - new test: geee/project_access_lists
                            - new test: functional/access_lists

SD-2002-01-15-1: Enhancem.: NEC SX-6 compilation changes:
                            Added missing strptime and fnmatch functions (from BSD)
                            Added support for NECSX6 architecture (maps to NECSX5)
                            Updated aimk and Makefiles
                            A few minor compiler related changes to source code

EB-2002-01-15-0: Enhancem.: 'qdel all' and 'qdel -uall' requests will
                            be split up into multiple requests

JG-2002-01-15-1: Bugfix:   qconf -mattr only handled string attributes, changing
                           attributes of other datatypes made qconf dump core.

AA-2002-01-15-0: Feature:  Security:
                           - sge_security_verify_user wraps sec method specific funcs                             sec_verify_user() and krb_verify_user() 
                           - addition of uniqueIdentifier to keep the Unix user name
                             to certificate generation scripts/templates
                           - xcheck between Unix user and certificate 
                             uniqueIdentifier field 

JG-2002-01-15-0: Testsuite: Fixed a problem of the submit_host check:
                            Replaced "hostname" with "uname -n" as hostname
                            is not found on some architectures (e.g. on irix6
                            hostname is located in /usr/bsd/bin).

JG-2002-01-14-1: Bugfix:    Removed duplicated code that caused the Insure++
                            debugger to (falsely) detect a READ_DANGLING error.

JG-2002-01-14-0: Enhancem.: execd_param SET_[SGE|COD|GRD]_ENV: If all types of
                            job environments are configured to be off, the 
                            default SGE is used.

CR-2002-01-11-0: Testsuite: wrong parsing for submit_job() produced error
                 Bugfix:    in qsub test. 

EB-2002-01-11-0: Bugfix:    not existing shell in jobscript in combination
                            with shell_start_mode=unix_behaviour set queue
                            and not job into error state.

AA-2002-01-11-0: Feature:   Security:
                            - scripts for generation/installation of certs, 1st draft under dist/util/sgeCA
                            - changes to script/distinst, script/distinst.site
                            
JG-2002-01-11-0: Bugfix:    Fixed a memory corruption bug (READ_DANGLING and 
                            FREE_DANGLING) in libcull.
                            Added code to suppress warnings from the Insure++
                            debugger for some correct code sections.
                            Make Insure++ output filenames and line numbers.

SD-2002-01-10-2: Enhancem:  Updated security modules aimk for linux

CR-2002-01-10-1: Testsuite: 
                            a) new sge_procedures:
                              - wait_for_job_state()
                              - wait_for_queue_state()
                            b) new test:
                              - system_tests/qmaster/error_states

SD-2002-01-10-1: Enhancem: Added SGEEE policy hierarchy support (not yet activated)
                           Minor GSS security modules update
                 Bugfix:   Fixed uninitialized structure in sge_calc_tickets

EB-2002-01-10-0: Bugfix:   qrsh -notify <command>

CR-2002-01-10-0: Testsuite:
                 Enhancem.: settings file parameter "user_environment"
                            Testsuite will read users environment value
                            if no var=value syntax is used. 
                            So if user_environment is set to DISPLAY the
                            testsuite will export the VALUE of the DISPLAY
                            variable on the local host to each remote host.
                    

JG-2002-01-10-1: Testsuite: Make the number of parallel rlogin sessions 
                            dependent on the limit for file handles.

JG-2002-01-10-0: Enhancem.: Additional check of the host parameter to 
                            qconf -ke - only accepts non option parameter.

EB-2002-01-09-0: Bugfix:   qselect -pe 
                 Bugtraq:  #4584673

SD-2002-01-09-1: Enhancem.: Added -clearusage info to qconf -help

AA-2002-01-09-0: Enhancem.: openssl lib path, I18N Linux uses libc gettext
                            -> changes in aimk

JG-2002-01-09-0: Enhancem.: qconf -ke has to be called with a host(list) or
                            the keyword "all". qconf -ke without hostlist no
                            longer kills all hosts.
                 IZ:        #83           

CR-2002-01-08-0: Testsuite: 
                    - New settings file version "4" because of new parameters
                      "dns_domain_name" and "user_environment".
                    - unsetting GRD_ROOT and CODINE_ROOT variables (if set) at
                      startup 
                    - qmod/reschedule test is now testing more, but still not
                      full implemented.
                    - changed output of handle_vi_edit()
                    - new parser procedure parse_qconf_se()
                    - commented open_root_spawn_process() this procedure
                      should not be used anymore. 
                      open_remote_spawn_process() should be used therefor.
                    - new procedures: 
                         get_complex(), set_complex(), get_qconf_se_info()
                    - enhanced sumbit_job() for specific error value handling                           
                    - new check:
                         system_tests/qmaster/complex

JG-2002-01-08-0: Enhancem.: Made "with I18N" default for solaris, solaris64
                            and glinux architectures.
                            Fixed broken build with I18N.

AH-2002-01-08-0: Cleanup:   Removed old and unused starter code in shepherd

JG-2002-01-07-1: Testsuite: handle_vi_edit sometimes "worked too fast" 
                            (modified file had same timestamp as original).
                            Added a sleep of one second.

JG-2002-01-07-0: Bugfix:    Fixed a memory leak in execd.
                            Added code to suppress warnings from the Insure++
                            debugger for some correct code sections.

AA-2001-12-21-0: Feature    added sge_ca script
                            RAND_load_file
                            sec_setup_path path changes

JG-2001-12-21-0: Enhancem.  Eliminate warnings from the Insure++ compiler

AA-2001-12-20-1: Feature:   Security: 
                            - commdcntl skips sge_security_init()
                            - unpack free of elem fix
                            - removal of obsolete setup routines in seclib

EB-2001-12-20-0: Bugfix:    Hold tid list of job submission dialog honours
                            tid range specification.
                 IZ:        None (Fix of Enhancem.: EB-2001-12-12-0) 

CR-2001-12-20-0: Testsuite: moved job start procedures from job_state_handling test
                            to the global sge_procedurs.tcl file.
                            (submit_waitjob_job(), submit_time_job(), submit_error_job())

EB-2001-12-19-0: Enhancem.: qmaster writes heartbeat-file during job deletion

CR-2001-12-19-1: Testsuite: new test: job_state_handling
                               - testing job states for array and "normal" jobs
                                 (hold, pending, running, finished, error, timehold
                                  jobhold, suspend is tested in qmod test)
                               - testing max_aj_instances
                               - testing max_aj_tasks
                            new parser procedure: parse_qstat_j() (parse qstat -j)
                            new procedure:  get_qstat_j_info() (get qstat -j information)
                            new procedure:  get_job_state() (parse qstat -f for job/array
                                                             states)
                 Bugfix:    unlock testsuite after fault tcl command code           
                               
CR-2001-12-19-0: Bugfix:    added missing ":" for qstat -j output for "job-array tasks"

AA-2001-12-19-0: Bugfix:    scrollbar anomalie in cluster config, made scrollbars static

JG-2001-12-19-1: Bugfix:    Limits were not correctly set on hp10 platform -
                            nonetheless most limits will have no effect due to
                            limitations of the hp10 platform.

JG-2001-12-19-0: Bugfix:    Limits did not work on glinux platform

JG-2001-12-18-1: Testsuite: - Fixed qsub check_submit - now it submits jobs from
                              any host to any host in the cluster as expected.
                            - extended tcl library function "submit_job" by 
                              parameters "host" on which to execute qsub 
                              and "user" as account that will execute qsub.

EB-2001-12-18-0: Bugfix:    'qstat -f' showed pending tasks multiple times 
                            Rescusciated '-g d' option of qstat
                 IZ:        None (Fix of Enhancem.: EB-2001-12-10-1)

JG-2001-12-18-0: Testsuite: - new test procedures in qsub and in qrsh tests
                              that test the starter_method.

SD-2001-12-17-2: Enhancem.: - added verbose information to get_cred security module
                            - updated DCE documentation

CR-2001-12-17-1: Feature:   - Grep for host-type and foreach loops, optimize via
                              first/next hash table functions.
                            - set exit state of qconf -ks to "1" if no scheduler
                              is enrolled
                            - is_requested() will accept CE_name AND CE_shortcut
                              now. 
 
AH-2001-12-17-0: Bugfix:    Ensure immediate return of sync send_message() in case
                            receiver is not enrolled

CR-2001-12-17-0: Testsuite: - handle_vi_edit procedure now uses now 
                              open_remote_spawn_id procedure
                            - bugfix in setup_queues / install_core_system check
                            - bugfix in performance/cluster/check.exp (hanging 
                              testsuite)

JG-2001-12-17-2: Bugfix:    Bugfix for JG-2001-12-17-0 handling "none" as
                            starter_method.

EB-2001-12-17-1: Bugfix:    qstat -j <job_id> did not show a monitoring message
                 IZ:        #113
                 Bugtraq:   #4614501

JG-2001-12-17-1: Testsuite: Testsuite framework will output stack trace
                            if a TCL error causes a test to fail.

JG-2001-12-17-0: Feature:   Implemented starter_method for qrsh.
                 IZ:        #6

EB-2001-12-17-0: Feature:   Compatibility mode (sge_request, SGE_*)

AH-2001-12-14-0: Bugfix:    SGE's hostaliasing can prevent qmaster restart
                 IZ:        #95
                 Bugtraq:   #4616534

AA-2001-12-14-1: Bugfix:    got a X protocol error, fixed -> AA-2001-12-14-0:

AA-2001-12-14-0: Bugfix:    Sharetree did not show the correct user data after
                            leaving and reentering the sharetree dialogue when
                            the sharetree had been scrolled down

JG-2001-12-14-0: Doc:       ADOC documentation for the event client interface.
                            HTML version in doc/devel, linked to module_doc.

EB-2001-12-13-0: Bugfix:    Qmaster automatically corrects invalid task id
                            ranges during job submittion.
                 IZ:        None (Fix of Enhancem.: EB-2001-12-10-1)

AA-2001-12-13-0: Feature:   added max_aj_instances and max_aj_tasks to global
                            cluster config
                            qmonMirrorMulti -> qmonMirrorMultiAnswer

EB-2001-12-12-0: Bugfix:    Changed/enhanced qmon's "Job Control" and "Job
                            Submission" dialog so that they respect unenrolled
                            pending tasks.
                 IZ:        None (Fix of Enhancem.: EB-2001-12-10-1)

JG-2001-12-12-0: Copyright: Create and link libXltree as shared lib; it is
                            LGPL Code.

EB-2001-12-11-0: Bugfix:    Printing of zombie jobs in qmon and qstat
                 IZ:        None (Fix of Enhancem.: EB-2001-12-10-1)

CR-2001-12-11-1: Testsuite: Start sgecommdcntl as root if root access is available

CR-2001-12-11-0: Testsuite: Using catch{} construct to suppress tcl errors when
                            creating a report message

JG-2001-12-11-0: Bugfix:    qrsh can not really ignore CTRL-Z (as intended by
                            JG-2001-12-10-0). Pressing CTRL-Z in a 
                            qrsh <command> session will suspend the rsh client.

EB-2001-12-10-1: Enhancem.: Memory optimization for zombie jobs

                            THE SPOOL FILE FORMAT FOR JOBS (CULL JOB STRUCTURE)
                            HAS BEEN CHANGED
                 
JG-2001-12-10-1: Testsuite: fixed qrsh test:
                            - accounting wrongly reported errors
                            - terminate test did no longer work for 
                              remote hosts

CR-2001-12-10-1: Feature:   remove unnecessary libs linked to commd

JG-2001-12-10-0: Bugfix:    qrsh/qlogin: if client command (rsh/rlogin/telnet)
                            exited abnormaly (signal, coredump etc.), the 
                            corresponding job will be deleted, assuring that 
                            no tasks keep running on the execution side.

CR-2001-12-10-0: Testsuite: using catch to prevent testsuite abort when a test 
                            produces a tcl error.

EB-2001-12-10-0: Bugfix:    Fix in sgeee scheduler where pending tickets 
                            are moved into the template for pending tasks 
                 IZ:        None (Fix of Enhancem.: EB-2001-12-04-0) 

AH-2001-12-07-0: Cleanup:   Improved diagnosis possibilities when commd is 
                            blocked NIS/DNS resolver library calls.

SD-2001-12-07-1: Bugfix:    Fixed ln command in distinst when creating security
                            distribution.
                 IZ:        None (Fix of Cleanup: SD-2001-12-06-4)

EB-2001-12-07-0: Bugfix:    Reanimated code for 'qconf -sep'
                 IZ:        None (Bug only appeared in beta1)

JG-2001-12-07-0: Bugfix:    scheduler could dump core in SGE systems with 
                            usersort and maxujobs activated, if no pending jobs
                            existed.
                 IZ:        None (Fix of Enhancem. JG-2001-12-06-1)

SD-2001-12-06-4: Cleanup:   Cleaned up the security gss modules for Kerberos
                            and DCE support.  Fixed a bug in get_cred.c.
                            Updated the HTML documentation on using the
                            GSS security modules. Updated aimk, Makefiles
                            and distinst to fully support security modules
                            or security binaries distributions.

EB-2001-12-06-3: Bugfix:    qstat -s r didn't show running jobs
                 IZ:        None (Fix of Enhancem.: EB-2001-12-04-0)

JG-2001-12-06-2: Testsuite: Adapt qmaster size test to use newer spawn function
                            open_remote_spawn_process.

JG-2001-12-06-1: Enhancem.: Performance improvement in scheduler if the
                            number of jobs/user is limited schedd config,
                            parameter maxujobs.

EB-2001-12-06-2: Bugfix:    Jobs submittet with start time in future where
                            never started
                            Qalter -hold_jid failed for unenrolled pending
                            jobs 
                 IZ:        None (Fix of Enhancem.: EB-2001-12-04-0)

CR-2001-12-06-1: Enhancem.: commd will only allow kill, trace, dump and unregister
                            commands when client (commdcntl) is using reserved
                            ports. Only a commd which was not started as root
                            will accept connections from other ports. 
                            
                            commdcntl can be switched to unsecure mode with -U
                            command line parameter.

CR-2001-12-06-0: Testsuite: modifications for new commdcntl -k enhancements.

EB-2001-12-06-1: Enhancem.: 'max_aj_tasks' defines the maximum number of 
                            allowed tasks within an array job. (75,000)
                            changed default value for 'max_aj_instances' (2000)

JG-2001-12-06-0: Bugfix:    Cull hash implementation: When cull objects were 
                            received and unpacked, all fields that did not 
                            have a hash table in the original had a unique
                            hash table created.

EB-2001-12-06-0: Bugfix:    It was not possible to modify the hold state
                            of tasks without task id specification.
                            (e.g. qalter -h u <jobid> failed)
                 IZ:        None (Fix of Enhancem.: EB-2001-12-04-0)

JG-2001-12-05-0: Testsuite: Adapt qrsh test to use newer spawn function
                            open_remote_spawn_process.

EB-2001-12-05-0: Bugfix:    Master got pending tickets for jobs which
                            where already started.
                 IZ:        None (Fix of Enhancem.: EB-2001-12-04-0)

SD-2001-12-04-1: Enhancem.: SGEEE - Added support for qconf -clearusage to reset
                            sharetree usage back to zero.

JG-2001-12-04-0: Bugfix:    shepherd: async commands had no valid filehandles
                            for stdin/stdout/stderr. This could cause the 
                            async command, e.g. a terminate method, to fail.

EB-2001-12-04-0: Enhancem.: Memory optimization for array jobs

AH-2001-12-03-0: Bugfix:    Resolve hostname contained in 'act_qmaster' file 
                            before comparing it with me.qualified_hostname

JG-2001-12-03-0: Testsuite: parsing of qstat -ext output did not return
                            correct cpu value.

AA-2001-11-30-4: Feature:   Security changes:
                            - common/complex.[ch] -> sge_complex.[ch]
                              due to name conflict when compiling under
                              linux

JG-2001-11-30-1: Enhancem.: Event client mechanism:
                            - any user may start an event client from an admin
                              or submit host
                            - changing event client parameters (subscription or
                              event delivery interval) does not take immediate
                              effect, but a number of changes can be made 
                              effective by a single qmaster communication.

JG-2001-11-30-0: Cleanup:   made a number of function parameters const

CR-2001-11-30-1: Bugfix:    qrsh error with empty job parameters
                 IZ:        #110
                 Bugtraq:   #4533448

AA-2001-11-30-4: Feature:   Security changes:
                            CSP seclib changes

CR-2001-11-30-0: Bugfix:    qsub parsing does not handle blanks on job args correctly
                 IZ:        #93
                            Only fixed qmaster output text ("your job X (...) has 
                            been submitted."), problem of lost blanks does not 
                            appear any more. Maybe someone else fixed it in an
                            other check in.

AA-2001-11-30-3: Feature:   Security changes:
                            - Makefiles, aimk, aimk.site
                              additions for CSP and Kerberos security 

AA-2001-11-30-2: Feature:   Security changes:
                            - Kerberos Makefiles, make it compilable with
                              const change

AA-2001-11-30-1: Feature:   Security changes:
                            - qtcsh Makefiles removed EXTRALIBS in gethost
                              buildrule for compilation in sec modes

AA-2001-11-30-0: Feature:   Security changes:
                            - introduced new product modes 
                              sge-csp and sgeee-csp belonging to feature
                              FEATURE_CSP_SECURITY
                            - replaced sec_subst.h and krb_subst.h mechanism
                              by runtime selection of security mode.
                              !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                              THE send_message[_pb] and receive_message calls
                              have been replaced by gdi_send_message[_pb] and
                              gdi_receive_message.
                              They are responsible for using the correct
                              mechanism. Please use these functions, if the 
                              underlying security layer shall be part of the 
                              communication.
                              !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                              As an improvement a communication context struct
                              could be introduced and initialized in the
                              setup phase.
                              To support the sec mechanisms compile with
                              aimk -secure 
                              or
                              aimk -kerberos
                              To run in secure mode the product_mode file
                              contains either sge(ee)-csp or sge(ee)-kerberos.
                            
                             
SD-2001-11-29-1: Bugfix:    SGEEE scheduler - Moved max_pending_functional_jobs
                            short-circuit to outer loop of pending functional
                            jobs algorithm to correct problem where certain
                            pending jobs were not considered for scheduling.

                            (read_write_host.c) removed unused hostname variable

JG-2001-11-29-0: Feature:   Event client mechanism:
                              - added new events for 
                                 - admin hosts
                                 - submit hosts
                                 - configuration changes
                                 - calendar
                                 - schedd info
                                 - manager
                                 - operator
                              - all event clients subscribe the events 
                                SHUTDOWN and QMASTER_GOES_DOWN and cannot 
                                unsubscribe these events
                            scheduler: 
                              - use subscription mechanism
                              - do not poll global configuration in each 
                                scheduling interval

AH-2001-11-29-2:            Removed unused exec host spool entries
                            'number_of_jobs' and 'real_host_name'

AH-2001-11-29-1: Bugfix:    qmaster logging "enrolled but leave_commd failed ..."
                 Bugtraq:   #4532798
                 IZ:        #108

AS-2001-11-29-0: Doc:       pseudo output variable $TASK_ID had wrong name
                            $SGE_TASK_ID.

AH-2001-11-28-1: Feature:   Enhanced accounting(5) file format for max vmem.
                            and PE taskid string. 

AS-2001-11-28-0: Bugfix:    remove unused and obsolete command line  
                            parameters in qmaster,scheduler"
                                -noread-argfile
				-nostart-schedd
				-nowrite-argfile
				-truncate-argfile
                            and scheduler:
                                -k
                                -salg
                 Bugtraq:   #4532233
		 Doc:       updated man pages sge_qmaster.8, sge_schedd.8
                            accordingly

AH-2001-11-28-0: Feature:   added enforce_project switch to cluster
                            configuration removed dead code on QSI/qstd. This
                            requires manual addition of a 'enforce_project'
                            field into the global configuration.

CR-2001-11-28-1: Testsuite: Conformation of the testsuite because of changes from
                            CR-2001-11-28-0, 
                 IZ:        #79, 
		 Bugtrag:   #4531719

CR-2001-11-28-0: Bugfix:    Reject changing of qmaster_spool_dir, execd_spool_dir
                            admin_user, default_domain and ignore_fqdn in running cluster.
 		 IZ:        #79
                 Bugtraq    #4531719          

AS-2001-11-26-0: Bugfix:    execd now exits on SIGTERM also when commd is down
                 Bugtraq:   #4531720

JG-2001-11-26-3: Feature:   Added a subscribe/unsubscribe mechanism to the
                            event client interface. The current
                            implementation does not yet allow dynamic
                            (un)subscription, but only before a
                            (re)registration.  Sort output of qconf -secl by
                            event client id.  Insert qevent to the Grid
                            Engine program and options handling.

CR-2001-11-26-0: Testsuite: Conformation of the testsuite because of changes
                            from AH-2001-11-23-1, Removed unused
                            configuration parameters

AH-2001-11-26-1: Bugfix:    Fix 'minus_n=0' problem in dist/mpi/rsh wrapper
                            script
                 Bugtraq:   #4532155
                 Build:     Fix error in generating rmon lib dependencies

AH-2001-11-26-0: Bugfix:    Fix qmaster problem with not existing task spool 
                            directory when task file is written.
                 Bugtraq:   #4532157

JG-2001-11-26-2: Feature:   Made qconf -secl use the new lHost datatype and
                            access functions (see CR-2001-11-23-1).

AA-2001-11-26-1: Bugfix:    Completion for qmon (-> AH-2001-11-23-1) 

JG-2001-11-26-1: Bugfix:    Fixed a (non critical) read to uninitialized
                            memory in the code retrieving memory load values
                            on Solaris.

JG-2001-11-26-0: Feature:   Added qconf options -secl (show event client list) and
                            -kec (kill event client).

AH-2001-11-23-1: Bugfix:    Removed unused configuration parameters in queue 
                            configuration and scheduler configuration 
                 IZ:        #71
                 Bugtraq:   #4431000 
                 
                            This requires manual removal of certain parameters before 
                            restarting daemons
                                - max_migr_time
                                - migr_load_thresholds
                                - max_no_migr
                                - klog
                                - reauth_time
                            from all queue configurations stored in 
                                $SGE_ROOT/default/spool/qmaster/queues/*
                            and 
                                - maxgjobs
                            from the scheduler configuration in
                                $SGE_ROOT/default/common/sched_configuration

                            This change is not yet done in qmon but only in
                            the core system. Please don't try to compile
                            qmon until qmon has been updated accordingly
                            (aimk -no-qmon).

AH-2001-11-23-0: Feature:   Enhanced queue priority range to -20 to +20
                            changed data type of queue priority from ulong
                            to string removed priority attribute from queue
                            complex

CR-2001-11-23-1: Feature:   Implementation of the lHostT cull data type.
                            Modified each cull list where a hostname is
                            stored. The lHostT data type is implemented like
                            the lStringT type, but only used for hostnames.

                 IssuZilla: #63 
                 Bugtraq:   #4531708

CR-2001-11-23-0: Testsuite: changed timeout behaviour in procedure 
                            open_remote_spawn_process

CR-2001-11-22-0: Testsuite: rework on auto_reschedule test
                            faster handle_vi_edit procedure

AH-2001-11-21-1: Feature:   Added NO_REPRIORIZATION setting in
                            qmaster_params to allow for diabling the PTF
                            module. Without this setting the 'priority'
                            parameter in queue_conf(5) has no effect in a
                            SGEEE system.

JG-2001-11-20-0: Feature:   Generalized event client interface.
                            The former event client interface was very
                            scheduler specific.  Only one event client - the
                            scheduler - could register.  Now any number of
                            event client can register at qmaster and receive
                            events.
                            A sample event client can be found in
                            clients/qevent.  Further cleanup steps and
                            documentation still has to be done.  A
                            subscribe/unsubscribe mechanism does not yet
                            exist.

AH-2001-11-20-0: Bugfix:    Use kstat interface instead of kvm interface for
                            retrieval of cpu percentage load value to fix
                            problems with Solaris 7,8 running 32-bit kernels
                 IssuZilla: #78
                 Bugtraq:   #4528905

SD-2001-11-19-0: Feature:   Added support for queue starter_method
                 IZ:        #6

AA-2001-11-19-0: Bugfix:    Qmon core dump in sharetree for empty sharetree
                            when using Find

JG-2001-11-15-0: Feature:   Performance/Scalability optimization: 
                            Defined hash tables on a number of objects to
                            speed up search operations.
                            Changed the order in which non unique hashed
                            objects are stored - some code relies on getting
                            them in the same order they were stored.

EB-2001-11-13-0: Bugfix:    Qmaster did not change the reschedule unknown
                            value immediately after using the qconf command.
                 IZ:           #92
                 Bugtraq:   #4525963

AA-2001-11-09-0: Build:     rename of commd constants to resolve namespace
                            conflicts for perlgui
                            added aimk -perlgui switch to build perlgui
                            security changes work in progress

CR-2001-11-08-0: Testsuite: - adapted default haftime scheduler parameter from 24 to 168
                            - new debug parameters chanched behaviour of
                              performance test when calling
                              open_remote_spawn_process - fixed
                            - changed deviation value for share tree check
                            - from 1% to 2%
                      
CR-2001-11-08-0: Testsuite: - new debuging options:
                              menu -> new points 20 and 21 
                              (shutdown/restart scheduler and master)
                              command line -> master_debug, schedd_debug and
                                      display master and scheduler can now
                                      be started in debug mode
                              - new procedure: wait_for_unknown_load
                              - (sge_procedures.tcl)


JG-2001-11-08-1: Feature:   New qconf options:
                               -Auser: add user from file
                               -Muser: modify user from file
                            Corrected sorting of options in help output.
                 IZ:        #89 

JG-2001-11-08-0: Bugfix:    Updated recent GDI versions for version check
                            and error handling in qmaster.

AS-2001-11-07-0: Created V53_beta1_TAG and V53_beta1_BRANCH Rel. SGE 5.3beta1
-----------------------------------------------------------------------------

JG-2001-11-07-2: aimk: recognize the necessity to set -DHAS_IN_PORT_T for 
                 the LINUX6 platform dependent on the libc version.

AA-2001-11-07-0: assure that cull_hash_free_descr get a valid descr

JG-2001-11-07-1: Bugfix: Retrieving a string value from a cull object field 
                 and setting this value again for the same field produced a 
                 memory access error.

JG-2001-11-07-0: Adjust MAKEOPT for aimk option -qmake to reflect latest
                 changes to qmake.

EB-2001-11-06-1: Fix: qdel of pending job task array took a long time



CR-2001-11-06-0: Testsuite:
                    - comparing reset_scheduler setup values on startup 
                      with the default from installation
                    - additional testing procedures for sharetree test
                    - setting default value for rlogin_max_open_connections
                      down to 20
                    - procedure reset_scheduler setup value update

EB-2001-11-06-0: classic_sgeee_scheduling=1 
                 => share_override_tickets=1
                 => share_functional_shares=0
                 => share_deadline_tickets=1


AA-2001-11-06-0: GE version of intro,logo.xpm, colors reduced

AA-2001-11-05-3: GE version of intro,logo.xpm

AA-2001-11-05-2: Fix for core dump if no submit/admin host in ticket dialogue

AA-2001-11-05-1: copyright for GE

AA-2001-11-05-0: obsolete pixmaps removed

AA-2001-10-31-0: copyright notice

EB-2001-11-05-0: Bugfix: Ckpt jobs and jobs exiting with exit state 99
                 could meet an old instance of the same job if the 
                 scheduler was to fast.

AH-2001-11-05-0: Fixes with qstat -pe <pe_name> and qselect -pe <pe_name>
                 - 'all' keyword in PE's queue_list was not honoured
                 - non-parallel queues were selected
                 Bugtraq: #4584673

JG-2001-11-02-1: qstat -j aborted when writing usage of pe tasks

JG-2001-11-02-0: qmake: Does not need to export variable PWD when executing 
                        remote tasks (qrsh option -v PWD) - PWD is setup 
                        correctly by execd/shepherd.

CR-2001-10-31-0: Testsuite:
                   Added new test for share tree in
                   checktree/system_tests/grd/sharetree/check.exp


JG-2001-10-31-3: Bugfix: Parsing of command line switches -ac, -dc, -sc and -v failed
                 if the value of the passed variable contained spaces, e.g.
                 -v EDITOR="gvim -f",DISPLAY=elendil:0.0 created the environment
                 variables EDITOR=gvim, -f="" and DISPLAY=elendil:0.0

JG-2001-10-31-2: -cwd option for tightly integrated pe tasks (qrsh -inherit)
                 did not overwrite the jobs -cwd settings.

JG-2001-10-31-1: Bugfix: qmon dumped core when displaying empty job args

JG-2001-10-31-0: Testsuite: Bugfix in submit_hosts test, did not work, 
                 if master host and submit_hosts test host had different
                 architecture.

EB-2001-10-30-1: Disabled modifications done in EB-2001-10-30-0

JG-2001-10-30-2: Testsuite: Accept new versions 
                  - SGE 5.3beta1
                  - SGEEE 5.3beta1

JG-2001-10-30-1: Bugfix: Could not start jobs with empty commandline arguments

AA-2001-10-30-1: Fix for functional ticket dialogue Success message

AA-2001-10-30-0: Fix for defaultdepartment callback
                 sensitivity of clusterparams IZ 81

JG-2001-10-30-0: qtcsh could not be compiled on newer linux systems (SuSE 7.2)
                 due to changes in the operating system include files

EB-2001-10-30-0: Modifications for sgeee scheduler
                  - Changed initial ticket count for started jobs
                  - Normalized pending job tickets 
                  - Changed several parameter for sgeee scheduler

JG-2001-10-29-0: Removed explicit hash tables on job lists in 
                 qmaster and scheduler - they are no longer needed, 
                 as cull hashing functionality was enabled for job
                 lists.

AH-2001-10-29-0: Qmaster:
                 - cancel resend of jobs to execd on forced job deletion

AA-2001-10-29-1: security files that are no longer needed removed

AA-2001-10-29-0: Fix for weired characters in helper dialogs (PE,Project Configi, 
                  Calendar, Cluster Config, Complex Config)
                 Queue Control Reschedule functionality added (corresponds qmod -r <qname>)
                 Cluster config Reschedule Unknown bug fixed 
                 Job Custom dialogue core dump fix

EB-2001-10-29-0: Fix for sgeee scheduler
                  - empty sharetree && sharetreetickets > 0 caused
                    fatal exit of scheduler

CR-2001-10-26-1: Testsuite:
                  - bugfix for path_alias check: problems with file
                    creating on NFS directory. The check will now make
                    sure that the correct/updated path_alias files are 
                    used (diffing file output on each execution host in
                    setup procedure). 

CR-2001-10-26-0: Source: 
                  - Added variable initialization
                  - Removed double defined message
                 Testsuite:
                  - using cvs -P parameter for source update
                  - issue #8 (one rlogin at startup):
                  - new parameter "close_rlogin" for compatibility

EB-2001-10-25-0: Modified qdel, qmon, qmaster
                  - removed job attribute vom "Job Customize" dialog
                  - bugfix: qdel -u <list of users>
                  - moved messages into msg_*.h file

JG-2001-10-25-0: Fixed some memory leaks

JG-2001-10-23-0: Fixed a bug in the implementation of non unique hash tables:
                 The key data has to be duplicated in the hash table.
                 Therefore a duplication function has to be passed when
                 creating a new hash table.

JG-2001-10-22-0: Fixed a memory access error in the cull hash implementation

EB-2001-10-20-0: Added 'const' in libraries

JG-2001-10-18-0: Execd:
                  - bugfix: reporting of a parallel array jobs pe task in
                            tight integration could fail.
                  - use cull hashing iterators for searches in job list          

JG-2001-10-17-0: (Issue #57)
                 Sparc Linux port (32 bit). Grid Engine platform slinux.
                 The port is restricted to SGE as the pdc module had to be 
                 disabled for slinux (aimk variable COMPILE_DC).

JG-2001-10-16-0: Implemented the use of hash tables for cull lists.
                 The list definition (libs/gdi/sge_*L.h) contains information, 
                 for which data fields hash tables shall be generated.
                 Hash tables are created and maintained by the cull list 
                 access functions (lCreateList, lAppendElem etc.) and are used
                 by the cull search functions (lGetElem*).
                 Defined default hash tables for the most used cull lists.
                 Increased the GDI version - the spooling file format and
                 the message format changed.

EB-2001-10-11-1: Changed MAX_SEQNUM from 999,999 to 9,999,999.
                 - changed qstat output format

EB-2001-10-11-0: Changed spool behaviour for (array) jobs
                 - beared down the 32765 subdirectory limit
                 - added some tuning parameters for job spooling
                 - collected duplicated code used in master and execd 

CR-2001-10-10-1: Testsuite:
                 - closed issue # 9 (Create a new test for file parsing)

CR-2001-10-10-0: Testsuite:
                 - new command line option: mfile FILE
                   (don't mail messages, write it to file)
                 - new optional parameter for procedure "wait_for_jobstart"
                   (do a qconf -tsm before waiting for jobstart) 

CR-2001-10-09-2: (sge_rusage.c)
                 - Issue #68 (The accounting file handles only entries < 2048 
                              chars/line)

CR-2001-10-09-1: (rmon_macros.c)
                 - don't use vnsprintf() for ALPHA4 and IRIX6

CR-2001-10-09-0: (parse_job_cull.c)
                 - Issue #67 (long lines in sge_request files causes bus error
                             in qsub)
                 - removed some local char str[1024] definitions and replaced
                   it with error_string buffer one function level above
                 (rmon_macros.c) 
                 - using vnsprintf() system call as default (instead of vsprintf)
                   This should prevent a buffer overflow error
                     
JG-2001-10-09-0: Added statistics for our hashtable implementation that gives
                 following info:
                  - size of hashtable and number of elements stored
                  - number of empty hash chains
                  - maximum and average chain length
                 When a hashtable is resized and log_level is set to log_debug,
                 statistics and profiling information is output to messages 
                 files.

JG-2001-10-08-0: Enabled options -h and -hold_jid for qrsh
                 Bugtraq #4511859

AH-2001-10-05-0: Removed warning message in execd 

EB-2001-10-05-0: minor modifications
                 - remove/displace code
                 - comments/formatting

JG-2001-10-04-0: Generalized our hash table implementation to support any
                 data type for keys.
                 Hash table uses hash and compare functions to be specified
                 when a table is created.
                 Hash and compare functions for strings and u_long32 are
                 provided.

EB-2001-10-04-0: (Issue #7)
                 - changed spool behaviour for (array) jobs

AH-2001-10-02-0: Schedd: Moved code handling 'forced' attributes to a section 
                 handling other static matchings. Static matchings can be done
                 independently of consumables/load values and thus needs be done
                 less frequent

SD-2001-10-01-0: Updated the SGEEE pending job algorithm.

                 WARNING - WARNING - WARNING - WARNING - WARNING - WARNING

                 This update changes the binary job structure spooled to disk.  
                 This means that if you are already running with the open source 
                 code, you will need to delete all pending and active jobs before 
                 running with the new SGE binaries. This is true if you are running 
                 either SGE or SGEEE.

CR-2001-09-26-0: Testsuite:
                 - new setup file version 
                 (new parameter "list_of_submit_only_hosts")
                 - bugfixes in path_alias test
                 - bugfix/enhancement in set_config procedure
                 - Issue #12: New test: submit_hosts test
                 

AH-2001-09-21-0: Improved array-job performance in schedd

CR-2001-09-21-0: Testsuite:
                 - New procedure in file_procedures module:
                   create_path_aliasing_file()
                 - Issue #54 : New test: sge_aliases file  

CR-2001-09-18-0: Testsuite:
                 - sending CR (carriage return) before starting remote command
                   (to stop eventually switched on correct questions) on rlogin
                   call
                 - wait longer before sending password (some login daemons
                   don't accept fast password typing)

CR-2001-09-17-0: Fixed issue #60 "COMMPROC ALLREADY REGISTERED" error

AH-2001-09-14-2: Fixed error with job array causing dispatch of the last
                 array-job being postponed to the follow-up scheduling interval

JG-2001-09-12-0: (Issue #58)
                 - scheduler optimization: sorting of hosts is only done
                   when really necessary.
                 - schedd can output profiling information - set schedd_params
                   to profile
                 - some smaller bugfixes  

AA-2001-09-06-0: Fixed y out of range of allowed Xserver values in QControl
                 This limits the number of displayable qs to 2758

JG-2001-09-03-0: (Issue #51)
                 - PWD was set incorrectly for jobs submitted with qsub -cwd
                   if a path mapping was active (sge_aliases file)
                 - qrsh does no longer use the PWD variable to determine 
                   target job working directory but jobs configuration

CR-2001-08-31-0: Testsuite:
                 - issue #10 shutdown_system_daemon does not work for some platforms
                 - start_remote_prog procedure can now export user environment on
                   remote host

EB-2001-08-30-0: Removed help output from qconf concerning 'meattr' 
                 and 'Meattr' (Issue# 50)

AA-2001-08-28-0: Fixed task array job handling in qmon submit dialogue (Issue# 48)

EB-2001-08-27-0: Fixed segmentation fault in qstat, qhost, qmon (Issue# 48)
                 - large, fragmented job arrays caused segmentation
                   fault in qstat when the task id range list should be
                   printed                                                                       
                 - hold of a list of array tasks in the job control dialog
                   caused only the last one to be set into the hold-state 

CR-2001-08-23-2: Testsuite:
                 - using full path name for files to check in procedure
                   check_executable_files 

CR-2001-08-23-1: Testsuite:
                 - removed add_proc_error call in compile_source procedure
                   (output buffer overflow error). Now the error is only
                   reported in the normal testsuite output. In case of
                   parallel compiling more architectures this error message
                   sometimes appears.

CR-2001-08-23-0: Testsuite:
                 - using cvs tag information for compile logfile name

JG-2001-08-22-0: (Issue# 43), host_aliases file was not implicitly used from 
                 standard location, option -a <path_to_host_aliases> worked.

AA-2001-08-22-0: - bugfix IZ 42, processing of projects/xprojects in SGEEE mode 

AA-2001-08-17-0: - enhanced scripts/snapshot.csh to use TAG as part of filename

JG-2001-08-13-0: fixed/improved handling of aimk option -opt (optimization)
                 at Ron Chen's suggestion.

AA-2001-08-09-0: - IZ 33, fixed duplicate free for scheduler conf dialogue code

AA-2001-08-07-0: - IZ 32, feature_is_enabled() used incorrectly

AH-2001-08-03-0: Accept -N job_name references in -hold_jid list 

JG-2001-08-02-0: Added external loadsensor script for platform aix43
                 (util/resources/loadsensors/ibm-loadsensor)

JG-2001-08-01-0: Testsuite: Test "cluster performance" failed on hosts reporting
                 a fully qualified hostname.

JG-2001-07-31-1: qrsh_starter: Handle (warn and ignore) empty environment
                 variable QRSH_WRAPPER

JG-2001-07-31-0: (Issue# 28): performance tests "cluster" and "scheduler" 
                 failed in sgeee systems

AA-2001-07-27-0: - Merge from branch: core dump fix for qmon_pe start/stop_proc_args

JG-2001-07-27-0: (Issue# 22): qdel to non existent job output inaccurate
                 error message

JG-2001-07-26-1: Maintrunc version:
                 - set Version string to "5.3 maintrunc"
                 - increased GDI version

AH-2001-07-26-0: - improved handling of waitpid() result in execd to trace into
                   the problem of shepherds considered to be finished by failure
                   (Origin 2000, Irix 6.5.10f)
                 - cleaned up on job logging code
                 - added job logging also to Schedd
                 - fixed typo in setfileperm.sh

CR-2001-07-26-1: Testsuite:
                    - create protocols directory on compile_source procedure
                      if it is not existing

CR-2001-07-26-0: Testsuite:
                    - added compile error output to mail on compile error
                    - added compile output log file generation in protocol dir 

JG-2001-07-26-0: (Issue# 15): startup_template: replaced fixed path by reference
                 to SGE_ROOT

CR-2001-07-25-2: Testsuite:
                    - modified compile mail output

CR-2001-07-25-1: Testsuite:
                    - CHECK_EXPECT_MATCH_MAX_BUFFER reset to 640 KB
                    - full_buffer caused not the error in compile_source procedure
                      (removed add_proc_error call in compile_source on full_buffer)
                      (full_buffer themes not to work correctly for multiple spawn/
                       expect calls)
                       

EB-2001-07-25-1: (Issue# 4) fixed build error (LINUX6, ALINUX)

EB-2001-07-25-0: (Issue# 5) qmaster - qconf:
                 - qconf -so|sm does not show comments anymore. 
                 - Comments will only be inserted into spoolfiles. 

CR-2001-07-25-0: Testsuite:
                    - reading CHECK_GROUP and CHECK_USER global variables from
                      check.exp file attributes if environment variables GROUP 
                      and USER aren't set.

CR-2001-07-24-1: uninitialzed variables error/warnings on linux in sge_job.c

CR-2001-07-24-0: Testsuite: 
                    - CHECK_EXPECT_MATCH_MAX_BUFFER set to 6,4 MB
                    - enable empty lines when reading in configuration files
                    - using env(HOST) only when HOST environment is set

JG-2001-07-24-1: qmaster - qdel:
                 - if a job is already in state deleted additional qdel's do 
                   not generate additional events to execd
                 - improved error output concerning tasks to be deleted 
                   (former output contained only job id), additional messages:
                   job "1595" task "4" does not exist
                   job "1595" task id range "1-4:2" comprises no tasks
                 - fixed bug in deletion of events to be resent  

JG-2001-07-24-0: Adoc: Function identifiers beginning with "-" 
                       (e.g. --Introduction) are not included in the function
                       index

CR-2001-07-23-0: Bugfix: qstat -j (Issue#: 2) causes 
                 "operation not implemented for target" error

EB-2001-07-23-0: Changed some html files
                 - link to contributor agreement
                 - added $ARCH variable to path (gethostname)
                 - deleted empty line in client output
                 - changed text width

CR-2001-07-20-0: Testsuite:
                 - qmod reschedule test is not completely implemented
                 - qrsh test showed error because of killing a job script
                   (exist status of expect child not 0) - disabled
                   error message for this open_spawn_process call
                 - shadowd migrate test can will stop if only one execution
                   host is in the cluster

AH-2001-07-20-0: - increased GRM_GDI_VERSION for GE 5.3
                 - fix qmaster core dump caused by old execd's sending load 
                   reports w/o REP_seqno
